#pragma once

#include "resource.h"

class DlgHlavni : 
	public CDialogImpl<DlgHlavni>
{
public:
	DlgHlavni()
	{
		comObject = NULL;
	}

	~DlgHlavni()
	{
	}

	enum { IDD = IDD_DLGHLAVNI };
	CComPtr <IPrvniComObject> comObject;
	CString nazev;

BEGIN_MSG_MAP(DlgHlavni)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDC_VYTVORIT,
		BN_CLICKED, OnVytvorit)
	COMMAND_HANDLER(IDC_ZRUSIT,
		BN_CLICKED, OnZrusit)
	COMMAND_HANDLER(IDC_METODA,
		BN_CLICKED, OnMetoda)
	COMMAND_HANDLER(IDC_METODA_2,
		BN_CLICKED, OnMetoda2)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		nazev.LoadString(IDS_PROJNAME);
		GetDlgItem(IDC_VYTVORIT).EnableWindow(TRUE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(FALSE);
		GetDlgItem(IDC_METODA).EnableWindow(FALSE);
		return 1;
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		if (comObject)
		{
			comObject.Release();
			comObject = NULL;
		}
		EndDialog(wID);
		return 0;
	}

	LRESULT OnVytvorit(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		if (comObject)
		{
			MessageBox(_T("Objekt je ji vytvoen"),
				nazev, MB_ICONEXCLAMATION);
			return 0;
		}
		HRESULT hr = 
			comObject.CoCreateInstance(__uuidof(PrvniComObject));
		if (FAILED(hr))
			EndDialog(IDCANCEL);
		GetDlgItem(IDC_VYTVORIT).EnableWindow(FALSE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(TRUE);
		GetDlgItem(IDC_METODA).EnableWindow(TRUE);
		return 0;
	}

	LRESULT OnZrusit(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		if (!comObject)
		{
			MessageBox(_T("Objekt nen vytvoen"),
				nazev, MB_ICONEXCLAMATION);
			return 0;
		}
		comObject.Release();
		comObject = NULL;
		CoFreeUnusedLibraries();
		GetDlgItem(IDC_VYTVORIT).EnableWindow(TRUE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(FALSE);
		GetDlgItem(IDC_METODA).EnableWindow(FALSE);
	}

	LRESULT OnMetoda(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		if (!comObject)
		{
			MessageBox(_T("Objekt nen vytvoen"),
				nazev, MB_ICONEXCLAMATION);
			return 0;
		}
		HRESULT hr = comObject->ZobrazitCas();
		return 0;
	}

	LRESULT OnMetoda2(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		CComPtr< IPrvniComObject > obj;
		if (FAILED(obj.CoCreateInstance(__uuidof(PrvniComObject))))
		{
			EndDialog(IDCANCEL);
			return 0;
		}
		obj->ZobrazitCas();
		obj.Release();
		obj = NULL;
		CoFreeUnusedLibraries();
		return 0;
	}
};
