/****************************************************
Klient komponenty Komponenta2
Soubor: DlgHlavni.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"

class DlgHlavni : 
	public CDialogImpl<DlgHlavni>
{
public:
	DlgHlavni()
	{
		comObjekt = NULL;
	}

	~DlgHlavni()
	{
		if (comObjekt)
		{
			comObjekt.Release();
			comObjekt = NULL;
		}
	}

	enum { IDD = IDD_DLGHLAVNI };
	CComPtr< IKomponenta2 > comObjekt;

BEGIN_MSG_MAP(DlgHlavni)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDC_JMENO_UZIVATELE,
		BN_CLICKED, OnJmenoUzivatele)
	COMMAND_HANDLER(IDC_VYUZITA_PAMET,
		BN_CLICKED, OnVyuzitaPamet)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg,
		WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if (FAILED(comObjekt.CoCreateInstance(__uuidof(Komponenta2))))
		{
			EndDialog(IDCANCEL);
			return 1;
		}
		OnVyuzitaPamet(0, 0, NULL, bHandled);
		return 1;
	}

	LRESULT OnKonec(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (comObjekt)
		{
			comObjekt.Release();
			comObjekt = NULL;
		}
		EndDialog(wID);
		return 0;
	}

	LRESULT OnVyuzitaPamet(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		ULONG fyzicka;
		ULONG procento;
		if (FAILED(comObjekt->GetVyuzitaPamet(
			&fyzicka, &procento)))
		{
			EndDialog(IDCANCEL);
			return 0;
		}
		wchar_t szText[40];
		StrFormatKBSize(fyzicka,
			szText,
			(sizeof(szText)-1) / sizeof(wchar_t));
		CString text;
		text.Format(L"Obsazeno fyz. pamti: %s ", szText);
		SetDlgItemText(IDC_OBSAZENA_PAMET, text);
		text.Format(L"Vyuito: %d ", procento);
		text.Append(L"%");
		SetDlgItemText(IDC_PROCENTO_PAMETI, text);
		return 0;
	}

	LRESULT OnJmenoUzivatele(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CComBSTR bstr;
		if (SUCCEEDED(comObjekt->GetJmenoUzivatele(&bstr)))
		{
			CString text;
			text.Format(L"Uivatel: %s",
				bstr.m_str);
			SetWindowText(text.GetBuffer());
			comObjekt->Zprava(bstr.m_str);
		}
		return 0;
	}
};
