#include "stdafx.h"

#include "resource.h"
#include "Klient.h"

class Aplikace : public CAtlExeModuleT< Aplikace >,
	public CDialogImpl < Aplikace >
{
public :
	DECLARE_LIBID(LIBID_ATLLib)

public :
	enum { IDD = IDD_HLAVNI };
	CComPtr< IComExe > comExe;

	BEGIN_MSG_MAP(Aplikace)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_HANDLER(IDOK, BN_CLICKED, OnKonec)
		COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnKonec)
		COMMAND_HANDLER(IDC_SPUSTIT, BN_CLICKED, OnSpustit)
		COMMAND_HANDLER(IDC_UKONCIT, BN_CLICKED, OnUkoncit)
		REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

	Aplikace()
	{
		comExe = NULL;
	}

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
		SetIcon(LoadIcon(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCE(IDI_HLAVNI)), TRUE);
		SetIcon(LoadIcon(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCE(IDI_HLAVNI)), FALSE);
		SetWindowText(L"Klient EXE komponenty");
		return 0;
	}

	HRESULT Aplikace::PreMessageLoop(int nShowCmd)
	{
		__super::PreMessageLoop(nShowCmd);
		Lock();
		INITCOMMONCONTROLSEX icc;
		icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC = ICC_WIN95_CLASSES |
			ICC_USEREX_CLASSES | ICC_DATE_CLASSES |
			ICC_LISTVIEW_CLASSES | ICC_COOL_CLASSES |
			ICC_BAR_CLASSES | ICC_INTERNET_CLASSES |
			ICC_NATIVEFNTCTL_CLASS | ICC_TAB_CLASSES |
			ICC_ANIMATE_CLASS;
		InitCommonControlsEx(&icc);
		DoModal();
		Unlock();
		return S_FALSE;
	}


	LRESULT Aplikace::OnKonec(WORD,	WORD wID, HWND, BOOL& bh)
	{
		if (comExe)
			OnUkoncit(0, 0, NULL, bh);
		EndDialog(wID);
		return 0;
	}


	LRESULT OnSpustit(WORD, WORD wID, HWND, BOOL&)
	{
		if (comExe)
			return 0;
		HRESULT hr;
		hr = comExe.CoCreateInstance(__uuidof(ComExe));
		return 0;
	}

	LRESULT OnUkoncit(WORD, WORD wID, HWND, BOOL&)
	{
		if (comExe)
		{
			comExe.Release();
			comExe = NULL;
		}
		return 0;
	}
};

Aplikace _aplikace;


// hlavn funkce win32 programu
extern "C" int WINAPI _tWinMain(HINSTANCE,
	HINSTANCE, LPTSTR, int nShowCmd)
{
    return _aplikace.WinMain(nShowCmd);
}

