/****************************************************
COM objekt v serveru typu exe 
Soubor: Aplikace.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include "Komponenta.h"


// tda Aplikace
class ATL_NO_VTABLE Aplikace : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Aplikace, &CLSID_ComExe>,
	public CWindowImpl < Aplikace >,
	public IDispatchImpl<IComExe, &IID_IComExe,
	&LIBID_KomponentaLib, 1, 0>
{
public:
static CWndClassInfo& GetWndClassInfo()
{
	static CWndClassInfo wc =
	{
		{
			sizeof(WNDCLASSEX),
			CS_DBLCLKS,
			StartWindowProc,
			0, 0,
			NULL,
			(HICON)LoadIcon(_AtlBaseModule.m_hInst,
				MAKEINTRESOURCEW(IDI_HLAVNI)),
			(HCURSOR)NULL,
			(HBRUSH)GetSysColorBrush(COLOR_INFOBK),
			NULL,
			L"ExeKomponenta",
			(HICON)LoadIcon(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCEW(IDI_HLAVNI))
		},
		NULL, // origname
		NULL, // wndproc
		IDC_ARROW, // cursor ID
		TRUE, // system cursor
		0, // atom
		L""
	};
	return wc;
}

public:
	static unsigned __stdcall ThreadProcServer(void* parametr)
	{
		Aplikace* aplikace = 
			(Aplikace*)parametr;
		RECT rect = { 0, 0, 200, 120};
		aplikace->Create(NULL, &rect,
			L"Exe COM", WS_POPUP | WS_BORDER);

		RECT rectOkno;
		RECT rectWork;
		if (!aplikace->GetWindowRect(&rectOkno))
			return -1;
		if (!SystemParametersInfo(SPI_GETWORKAREA,
			0, &rectWork, 0))
			return -1;
		aplikace->SetWindowPos(NULL,
			rectWork.right - (rectOkno.right - rectOkno.left),
			rectWork.bottom - (rectOkno.bottom - rectOkno.top),
			0, 0, SWP_NOSIZE | SWP_NOZORDER);

		aplikace->ShowWindow(SW_SHOW);
		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (aplikace->hThread)
		{
			if (!CloseHandle(aplikace->hThread))
				AtlThrowLastWin32();
			aplikace->hThread = NULL;
		}
		return 0;
	}

public:
	HANDLE hThread;

public:
	Aplikace()
	{
		hThread = NULL;
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_COMEXE)
	DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Aplikace)
	COM_INTERFACE_ENTRY(IComExe)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

BEGIN_MSG_MAP(Aplikace)
	MESSAGE_HANDLER(WM_CLOSE, OnClose)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
END_MSG_MAP()


	HRESULT FinalConstruct()
	{
		unsigned int ui;
		hThread = (HANDLE)
			_beginthreadex(NULL, 0,
			ThreadProcServer,
			(void*)this, 0, &ui);
		if (!hThread)
			return E_FAIL;
		return S_OK;
	}
	
	void FinalRelease() 
	{
		if (hThread)
		{
			PostMessage(WM_CLOSE, 1);
			Sleep(500);
		}
	}

	LRESULT OnClose(UINT, WPARAM wparam,
		LPARAM, BOOL&)
	{
		if (wparam != 1)
			return 0;
		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT, WPARAM,
		LPARAM, BOOL&)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnPaint(UINT, WPARAM,
		LPARAM, BOOL&)
	{
		PAINTSTRUCT ps;
		RECT rect;
		GetClientRect(&rect);
		HDC hdc = BeginPaint(&ps);
		SetTextColor(hdc, GetSysColor(COLOR_INFOTEXT));
		SetBkMode(hdc, TRANSPARENT);
		DrawText(hdc, L"Exe komponenta",
			-1,	&rect,
			DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		EndPaint(&ps);
		return 0;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(ComExe), Aplikace)
