// DlgTextEditor.h : Declaration of the DlgTextEditor

#pragma once

#include "resource.h"       // main symbols
#include <atlhost.h>


// DlgTextEditor

class DlgTextEditor : 
	public CAxDialogImpl<DlgTextEditor>
{
public:
	DlgTextEditor()
	{
	}

	~DlgTextEditor()
	{
	}

	enum { IDD = IDD_DLGTEXTEDITOR };
	CAxWindow2 axWindow;
	ITextEditAx* textEdit;

BEGIN_MSG_MAP(DlgTextEditor)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
	MESSAGE_HANDLER(WM_SIZE, OnSize)
	COMMAND_ID_HANDLER(ID_ZOBRAZIT_TOOLBAR, OnZobrazitToolbar)
	CHAIN_MSG_MAP(CAxDialogImpl<DlgTextEditor>)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		CAxDialogImpl<DlgTextEditor>::
			OnInitDialog(uMsg, wParam, lParam, bHandled);
		HRESULT hr;
		axWindow = GetDlgItem(IDC_TEXT_EDITOR);
		hr = axWindow.QueryControl(&textEdit);
		if (hr != S_OK)
			EndDialog(IDCANCEL);
		return 1;
	}

	LRESULT OnClickedOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}

	LRESULT OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (axWindow.IsWindow())
			axWindow.SetWindowPos(NULL,
			0, 0,
			LOWORD(lParam), HIWORD(lParam),
			SWP_NOZORDER);
		return 0;
	}


	LRESULT OnZobrazitToolbar(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		VARIANT_BOOL bex;
		textEdit->ToolBarExistuje(&bex);
		if (bex)
			textEdit->ZobrazitToolBar(FALSE);
		else
			textEdit->ZobrazitToolBar(TRUE);
		return 0;
	}
};
