#include "StdAfx.h"
#include ".\DemoAplikace.h"
#include ".\OknoHlavni.h"
#include ".\DlgAxTestKontejner.h"
#include ".\DlgTextEditor.h"
#include ".\DlgUdalosti.h"
#include ".\DlgZaznamZvuku.h"

OknoHlavni _oknoHlavni;

OknoHlavni::OknoHlavni()
{
	seznamModulu = NULL;
}

OknoHlavni::~OknoHlavni()
{
	oknoPlus.Release();
	oknoPlus = NULL;
}

LRESULT OknoHlavni::OnDestroy(UINT uMsg, WPARAM wParam,
	LPARAM lParam, BOOL& bHandled)
{
	PostQuitMessage(0);
	return DefWindowProc();
}

LRESULT OknoHlavni::OnClose(UINT uMsg, WPARAM wParam,
	LPARAM lParam, BOOL& bHandled)
{
	oknoPlus->Uvolnit();
	if (seznamModulu)
	{
		seznamModulu.Release();
		seznamModulu = NULL;
	}
	return DefWindowProc();
}

void OknoHlavni::Vytvorit(void)
{
	RECT rect = {0, 0, 794, 570};
	if (!Create(NULL, &rect, _aplikace.jmeno,
		WS_OVERLAPPEDWINDOW, 0))
		_aplikace.FatalniChyba();
	CenterWindow();
	HRESULT hr = oknoPlus.CoCreateInstance(__uuidof(OknoPlus));
	if (hr != S_OK)
		_aplikace.FatalniChyba();
	hr = oknoPlus->Nastavit((OLE_HANDLE)m_hWnd);
	if (hr != S_OK)
		_aplikace.FatalniChyba();
	oknoPlus->put_MinimalizovatDoTrayIkony(VARIANT_TRUE);
	oknoPlus->put_PolozkySysNabidky(VARIANT_TRUE);
	oknoPlus->put_PolozkySysNabidky(VARIANT_TRUE);
	oknoPlus->put_TazeniMysi(VARIANT_TRUE);
	oknoPlus->put_ZavritNaEscape(VARIANT_TRUE);
	ShowWindow(SW_SHOW);
}

LRESULT OknoHlavni::OnKonec(WORD wNotifyCode,
	WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	PostMessage(WM_CLOSE);
	return 0;
}

LRESULT OknoHlavni::OnAxTestKontejner(
	WORD wNotifyCode, WORD wID,
	HWND hWndCtl, BOOL& bHandled)
{
	DlgAxTestKontejner dlg;
	dlg.DoModal();
	return 0;
}

LRESULT OknoHlavni::OnTextEditor(
	WORD wNotifyCode, WORD wID,
	HWND hWndCtl, BOOL& bHandled)
{
	DlgTextEditor dlg;
	dlg.DoModal();
	return 0;
}

LRESULT OknoHlavni::OnZaznamZvuku(
	WORD wNotifyCode, WORD wID,
	HWND hWndCtl, BOOL& bHandled)
{
	DlgZaznamZvuku().DoModal();
	return 0;
}

LRESULT OknoHlavni::OnTestUdalosti(
	WORD wNotifyCode, WORD wID,
	HWND hWndCtl, BOOL& bHandled)
{
	DlgUdalosti().DoModal();
	return 0;
}

LRESULT OknoHlavni::OnModulyAplikace(WORD wNotifyCode,
	WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (!seznamModulu)
	{
		if (FAILED(seznamModulu.CoCreateInstance(
			__uuidof(SeznamModulu))))
		{
			_aplikace.ZobrazitPosledniChybu();
			return 0;
		}
		seznamModulu->Spustit(_aplikace.jmeno.GetBuffer(),
			(OLE_HANDLE)LoadIcon(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCE(IDI_HLAVNI)));
		CheckMenuItem(GetMenu(),
			ID_MODULY_APLIKACE,
			MF_CHECKED | MF_BYCOMMAND);
	}
	else
	{
		seznamModulu.Release();
		seznamModulu = NULL;
		CheckMenuItem(GetMenu(),
			ID_MODULY_APLIKACE,
			MF_UNCHECKED | MF_BYCOMMAND);
	}

	return 0;
}
