// ElipsaAx.h : Declaration of the ElipsaAx
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "ElipsaAxObj.h"
#include "_IElipsaAxEvents_CP.h"

// ElipsaAx
class ATL_NO_VTABLE ElipsaAx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<ElipsaAx, IElipsaAx>,
	public IPersistStreamInitImpl<ElipsaAx>,
	public IOleControlImpl<ElipsaAx>,
	public IOleObjectImpl<ElipsaAx>,
	public IOleInPlaceActiveObjectImpl<ElipsaAx>,
	public IViewObjectExImpl<ElipsaAx>,
	public IOleInPlaceObjectWindowlessImpl<ElipsaAx>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<ElipsaAx>,
	public CProxy_IElipsaAxEvents<ElipsaAx>, 
	public IPersistStorageImpl<ElipsaAx>,
	public ISpecifyPropertyPagesImpl<ElipsaAx>,
	public IQuickActivateImpl<ElipsaAx>,
	public IDataObjectImpl<ElipsaAx>,
	public IProvideClassInfo2Impl<&CLSID_ElipsaAx,
		&__uuidof(_IElipsaAxEvents), &LIBID_ElipsaAxObjLib>,
	public CComCoClass<ElipsaAx, &CLSID_ElipsaAx>,
	public CComControl<ElipsaAx>
{
public:

	ElipsaAx()
	{
		m_clrFillColor = 0x0080FFFF;
		m_bWindowOnly = TRUE;
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_ELIPSAAX)

BEGIN_COM_MAP(ElipsaAx)
	COM_INTERFACE_ENTRY(IElipsaAx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(ElipsaAx)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("FillColor", DISPID_FILLCOLOR, CLSID_StockColorPage)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(ElipsaAx)
	CONNECTION_POINT_ENTRY(__uuidof(_IElipsaAxEvents))
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(ElipsaAx)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	CHAIN_MSG_MAP(CComControl<ElipsaAx>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IElipsaAx,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IElipsaAx
public:
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		COLORREF crBarva;
		OleTranslateColor(m_clrFillColor,
			NULL, &crBarva);
		HBRUSH hBrush;
		hBrush = CreateSolidBrush(crBarva);
		HRGN hRgnOld = NULL;
		if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
			hRgnOld = NULL;
		bool bSelectOldRgn = false;
		HRGN hRgnNew = CreateRectRgn(rc.left,
			rc.top, rc.right, rc.bottom);
		if (hRgnNew != NULL)
		{
			bSelectOldRgn = (SelectClipRgn(
				di.hdcDraw, hRgnNew) != ERROR);
		}
		HBRUSH hbOrig = (HBRUSH)
			SelectObject(di.hdcDraw, hBrush);
		Ellipse(di.hdcDraw, rc.left,
			rc.top, rc.right, rc.bottom);
		SelectObject(di.hdcDraw, hbOrig);
		if (bSelectOldRgn)
			SelectClipRgn(di.hdcDraw, hRgnOld);
		DeleteObject(hBrush);
		if (hRgnNew)
			if (!DeleteObject(hRgnNew))
				return E_FAIL;
		return S_OK;
	}

	OLE_COLOR m_clrFillColor;
	void OnFillColorChanged()
	{
		ATLTRACE(_T("OnFillColorChanged\n"));
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	LRESULT OnLButtonDown(UINT uMsg,
		WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		CString text;
		text.Format(L"Bude vyvolna udlost Klik s parametry:\n"
			L"pozice x: %d\n"
			L"pozice y: %d\n"
			L"klvesy: %d",
			(int)LOWORD(lParam),
			(int)HIWORD(lParam),
			(int)(wParam));
		MessageBox(text,
			L"Zprva ActiveX prvku",
			MB_ICONINFORMATION);
		Fire_Klik((LONG)LOWORD(lParam),
			(LONG)HIWORD(lParam),
			wParam);
		return 0;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(ElipsaAx), ElipsaAx)
