// FontComboBoxAx.h : Declaration of the FontComboBoxAx
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "FontComboBoxObj.h"
#include "_IFontComboBoxAxEvents_CP.h"

// FontComboBoxAx
class ATL_NO_VTABLE FontComboBoxAx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IFontComboBoxAx, &IID_IFontComboBoxAx, &LIBID_FontComboBoxObjLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<FontComboBoxAx>,
	public IOleControlImpl<FontComboBoxAx>,
	public IOleObjectImpl<FontComboBoxAx>,
	public IOleInPlaceActiveObjectImpl<FontComboBoxAx>,
	public IViewObjectExImpl<FontComboBoxAx>,
	public IOleInPlaceObjectWindowlessImpl<FontComboBoxAx>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<FontComboBoxAx>,
	public CProxy_IFontComboBoxAxEvents<FontComboBoxAx>, 
	public IPersistStorageImpl<FontComboBoxAx>,
	public ISpecifyPropertyPagesImpl<FontComboBoxAx>,
	public IQuickActivateImpl<FontComboBoxAx>,
	public IDataObjectImpl<FontComboBoxAx>,
	public IProvideClassInfo2Impl<&CLSID_FontComboBoxAx, &__uuidof(_IFontComboBoxAxEvents), &LIBID_FontComboBoxObjLib>,
	public CComCoClass<FontComboBoxAx, &CLSID_FontComboBoxAx>,
	public CComControl<FontComboBoxAx>
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)NULL,
				(HCURSOR)NULL,
				(HBRUSH)NULL,
				NULL, // menu
				L"FontComboBoxAxControl",
				(HICON)NULL
			},
			NULL,
			NULL, // wndproc
			IDC_CROSS, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}
	static int CALLBACK EnumFontFamExProc(ENUMLOGFONTEX* lpelfe,
		NEWTEXTMETRICEX* lpntme,
		DWORD FontType,
		LPARAM lParam)
	{
	//		if( ((FontComboBoxAx*)lParam)->trueType)
	//			if (FontType == RASTER_FONTTYPE)
	//				return 1;
		::SendMessage((HWND)(
			(FontComboBoxAx*)lParam)->m_ctlComboBox.m_hWnd,
			CB_ADDSTRING,0, (LPARAM)lpelfe->elfFullName);
		return 1;
	}

public:
	CContainedWindow m_ctlComboBox;
	LONG fontHeight;
	ULONG rozbalenaVyska;
	HFONT hFont;

#pragma warning(push)
#pragma warning(disable: 4355) // 'this' : used in base member initializer list

	FontComboBoxAx()
		: m_ctlComboBox(_T("ComboBox"), this, 1)
	{
		m_bWindowOnly = TRUE;
		rozbalenaVyska = 420;
		hFont = NULL;
		LOGFONT lf;
		GetObject(GetStockObject(DEFAULT_GUI_FONT),
			sizeof(lf), &lf);
		fontHeight = lf.lfHeight;
	}

#pragma warning(pop)

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_FONTCOMBOBOXAX)

BEGIN_COM_MAP(FontComboBoxAx)
	COM_INTERFACE_ENTRY(IFontComboBoxAx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(FontComboBoxAx)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("RozbalenaVyska", 1, CLSID_NULL)
	PROP_ENTRY("FontHeight", 3, CLSID_NULL)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(FontComboBoxAx)
	CONNECTION_POINT_ENTRY(__uuidof(_IFontComboBoxAxEvents))
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(FontComboBoxAx)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_DRAWITEM, OnDrawItem)
	MESSAGE_HANDLER(WM_MEASUREITEM, OnMeasureItem)
	COMMAND_HANDLER(1, CBN_SELCHANGE, OnCbnSelchange)
	CHAIN_MSG_MAP(CComControl<FontComboBoxAx>)
ALT_MSG_MAP(1)
	// Replace this with message map entries for superclassed ComboBox
END_MSG_MAP()

	BOOL PreTranslateAccelerator(LPMSG pMsg, HRESULT& hRet)
	{
		if(pMsg->message == WM_KEYDOWN)
		{
			switch(pMsg->wParam)
			{
			case VK_LEFT:
			case VK_RIGHT:
			case VK_UP:
			case VK_DOWN:
			case VK_HOME:
			case VK_END:
			case VK_NEXT:
			case VK_PRIOR:
				hRet = S_FALSE;
				return TRUE;
			}
		}
		return FALSE;
	}

	LRESULT OnCbnSelchange(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		int vyber = 
			m_ctlComboBox.SendMessage(CB_GETCURSEL);
		if (vyber < 0)
			return 0;
		CString text;
		GetText(vyber, text);
		Fire_ZmenaVyberu(text.GetBuffer());
		return 0;
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lRes = CComControl<FontComboBoxAx>::OnSetFocus(uMsg, wParam, lParam, bHandled);
		if (m_bInPlaceActive)
		{
			if(!IsChild(::GetFocus()))
				m_ctlComboBox.SetFocus();
		}
		return lRes;
	}

	LRESULT OnCreate(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		RECT rc;
		GetWindowRect(&rc);
		rc.right -= rc.left;
		rc.bottom -= rc.top;
		rc.top = rc.left = 0;
		m_ctlComboBox.Create(m_hWnd, rc, NULL,
			WS_CHILD | WS_VISIBLE |
			CBS_DROPDOWNLIST |
			CBS_OWNERDRAWVARIABLE |
			CBS_HASSTRINGS | WS_VSCROLL | 
			WS_TABSTOP, 0,
			1);
		Naplnit();
		return 0;
	}

	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<FontComboBoxAx>::
			SetObjectRects(prcPos, prcClip);
		::SetWindowPos(m_ctlComboBox.m_hWnd,
			NULL, 0, 0,
			prcPos->right - prcPos->left,
			this->rozbalenaVyska,
			SWP_NOZORDER | SWP_NOACTIVATE);
		return S_OK;
	}

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IFontComboBoxAx,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IFontComboBoxAx

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
		if (hFont)
			if (!DeleteObject(hFont))
				AtlThrowLastWin32();
		hFont = NULL;
	}

	int Naplnit()
	{
		if (!IsWindow())
			return -1;
		m_ctlComboBox.SendMessage(CB_RESETCONTENT);
		m_ctlComboBox.SetRedraw(FALSE);
		HDC hdc = GetDC();
		LOGFONT logfont;
		memset(&logfont, 0, sizeof(logfont));
		EnumFontFamiliesEx(hdc, &logfont,
			(FONTENUMPROC)EnumFontFamExProc,
			(LPARAM)this, 0);
		ReleaseDC(hdc);
		if (m_ctlComboBox.SendMessage(CB_GETCOUNT) > 0)
			m_ctlComboBox.SendMessage(CB_SETCURSEL, 0);
		m_ctlComboBox.SetRedraw(TRUE);
		return (int)m_ctlComboBox.SendMessage(CB_GETCOUNT);
	}

	void GetText(int nIndex, CString& text)
	{
		LRESULT delka = 
			m_ctlComboBox.SendMessage(CB_GETLBTEXTLEN, nIndex);
		if (delka == CB_ERR)
			return;
		if (m_ctlComboBox.SendMessage(CB_GETLBTEXT, (WPARAM)nIndex,
			(LPARAM)text.GetBufferSetLength((int)delka))
			== CB_ERR)
		{
			text.ReleaseBuffer();
			return;
		}
		else
			text.ReleaseBuffer();
	}

	LRESULT OnMeasureItem(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		((MEASUREITEMSTRUCT*)lParam)->itemHeight = 26;
		return 0;
	}

	LRESULT OnDrawItem(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		CString text;
		GetText(((DRAWITEMSTRUCT*)lParam)->itemID, text);
		HBRUSH hbPozadi;
		if (((DRAWITEMSTRUCT*)lParam)->itemState & ODS_SELECTED)
		{
			hbPozadi = GetSysColorBrush(COLOR_HIGHLIGHT);
			SetTextColor(((DRAWITEMSTRUCT*)lParam)->hDC,
				GetSysColor(COLOR_HIGHLIGHTTEXT));
		}
		else
		{
			hbPozadi = GetSysColorBrush(COLOR_WINDOW);
			SetTextColor(((DRAWITEMSTRUCT*)lParam)->hDC,
				GetSysColor(COLOR_WINDOWTEXT));
		}
		SetBkMode(((DRAWITEMSTRUCT*)lParam)->hDC, TRANSPARENT);
		FillRect(((DRAWITEMSTRUCT*)lParam)->hDC,
			&((DRAWITEMSTRUCT*)lParam)->rcItem,
			hbPozadi);
		((DRAWITEMSTRUCT*)lParam)->rcItem.left += 6;
		LOGFONT logfont;
		GetObject(GetStockObject(DEFAULT_GUI_FONT),
			sizeof(logfont), &logfont);
		lstrcpy(logfont.lfFaceName, text.GetBuffer());
		logfont.lfHeight = -14;
		HFONT hFont = CreateFontIndirect(&logfont);
		HFONT hfOrig = 
			(HFONT)SelectObject(((DRAWITEMSTRUCT*)lParam)->hDC,
			hFont);
		DrawText(((DRAWITEMSTRUCT*)lParam)->hDC,
			text.GetBuffer(), -1,
			&((DRAWITEMSTRUCT*)lParam)->rcItem,
			DT_SINGLELINE | DT_VCENTER);
		SelectObject(((DRAWITEMSTRUCT*)lParam)->hDC, hfOrig);
		if (!DeleteObject(hFont))
			AtlThrowLastWin32();
		return 0;
	}

	virtual HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		return S_OK;
	}

	STDMETHOD(get_RozbalenaVyska)(ULONG* pVyska)
	{
		*pVyska = rozbalenaVyska;
		return S_OK;
	}

	STDMETHOD(put_RozbalenaVyska)(ULONG novaVyska)
	{
		if (novaVyska < 30 ||
			novaVyska > GetSystemMetrics(SM_CYSCREEN))
			return E_INVALIDARG;
		rozbalenaVyska = novaVyska;
		return S_OK;
	}
	

	STDMETHOD(get_HFont)(OLE_HANDLE* pFont)
	{
		if (hFont)
			if (!DeleteObject(hFont))
				AtlThrowLastWin32();
		hFont = NULL;
		if (!m_ctlComboBox.IsWindow())
			return S_OK;
		int vyber = (int)
			m_ctlComboBox.SendMessage(CB_GETCURSEL);
		if (vyber < 0)
			return S_OK;
		CString text;
		GetText(vyber, text);
		LOGFONT logfont;
		GetObject(GetStockObject(DEFAULT_GUI_FONT),
			sizeof(logfont), &logfont);
		lstrcpy(logfont.lfFaceName, text.GetBuffer());
		logfont.lfHeight = fontHeight;
		hFont = CreateFontIndirect(&logfont);
		if (!hFont)
			AtlThrowLastWin32();
		*pFont = (OLE_HANDLE)hFont;
		return S_OK;
	}

	STDMETHOD(get_FontHeight)(LONG* pHeight)
	{
		*pHeight = fontHeight;
		return S_OK;
	}

	STDMETHOD(put_FontHeight)(LONG Height)
	{
		fontHeight = Height;
		return S_OK;
	}

	STDMETHOD(SetVyber)(BSTR nazevPisma)
	{
		int pocet = m_ctlComboBox.SendMessage(CB_GETCOUNT);
		CString text;
		for (int i = 0; i < pocet; i++)
		{
			GetText(i, text);
			if (text.CompareNoCase(nazevPisma) == 0)
			{
				m_ctlComboBox.SendMessage(
					CB_SETCURSEL, i);
				return S_OK;

			}
		}
		return S_FALSE;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(FontComboBoxAx), FontComboBoxAx)
