/****************************************************
Projekt: Hodiny
Soubor: OknoHlavni.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include ".\oknohodiny.h"

class OknoHlavni : public CWindowImpl< OknoHlavni >
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),// ikona
				(HCURSOR)NULL,
				(HBRUSH)GetSysColorBrush(COLOR_WINDOW),
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				_T("MojeHlavniOkno"),
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)) // mal ikona
			},
			NULL,
			NULL, // wndproc
			IDC_CROSS, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}

public:
	OknoHodiny oknoHodiny;

public:
	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
		COMMAND_ID_HANDLER(ID_ZOBRAZIT_HODINY, OnZobrazitHodiny)
		MESSAGE_HANDLER(WM_MENUSELECT, OnMenuSelect)
	END_MSG_MAP()

	bool Vytvorit()
	{
		RECT rect = {0, 0, 400, 270};
		if (!Create(NULL, &rect, _T("Hodiny"),
			WS_OVERLAPPEDWINDOW))
			return false;
		CenterWindow();
		ShowWindow(SW_SHOW);
		return true;
	}

	LRESULT OnClose(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (oknoHodiny.hThread)
		{
			oknoHodiny.PostMessage(WM_CLOSE);
			Sleep(150);
		}
		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnZobrazitHodiny(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		if (oknoHodiny.hThread)
			oknoHodiny.PostMessage(WM_CLOSE);
		else
			oknoHodiny.Zapnout();
		return 0;
	}

	LRESULT OnMenuSelect(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (LOWORD(wParam) == 1)
		{
			if (oknoHodiny.hThread)
				CheckMenuItem(GetMenu(), ID_ZOBRAZIT_HODINY,
				MF_BYCOMMAND | MF_CHECKED);
			else
				CheckMenuItem(GetMenu(), ID_ZOBRAZIT_HODINY,
				MF_BYCOMMAND | MF_UNCHECKED);
		}
		return 0;
	}
};
