/*****************************************************
Projekt: Hodiny
Soubor: OknoHodiny.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

class OknoHodiny : public CWindowImpl< OknoHodiny >
{
public:
	static unsigned __stdcall ThreadProc(void* okno)
	{
		RECT rect = {((OknoHodiny*)okno)->xPoz,
            ((OknoHodiny*)okno)->yPoz,
			((OknoHodiny*)okno)->xPoz + 100,
			((OknoHodiny*)okno)->yPoz + 25};
		if (!((OknoHodiny*)okno)->Create(NULL, &rect, NULL,
			WS_POPUP | WS_BORDER))
			return false;
		((OknoHodiny*)okno)->SetTimer(1, 1000);
		((OknoHodiny*)okno)->ShowWindow(SW_SHOW);
		MSG msg;
		while (GetMessage(&msg, 0, 0, 0) > 0)
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (!CloseHandle(((OknoHodiny*)okno)->hThread))
			AtlThrowLastWin32();
		((OknoHodiny*)okno)->hThread = NULL;
		return 0;
	}
public:
	HANDLE hThread;
	int xPoz;
	int yPoz;

	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
	END_MSG_MAP()

	OknoHodiny()
	{
		hThread = NULL;
		xPoz = 0;
		yPoz = 0;
	}

	LRESULT OnClose(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		KillTimer(1);
		RECT rect;
		GetWindowRect(&rect);
		this->xPoz = rect.left;
		this->yPoz = rect.top;
		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		SendMessage(WM_SYSCOMMAND, SC_MOVE | HTCAPTION, 0);
		return DefWindowProc();
	}

	bool Zapnout()
	{
		if (this->hThread)
			return false;
		unsigned int ui;
		this->hThread = (HANDLE)_beginthreadex(NULL, 0,
			OknoHodiny::ThreadProc, (void*)this, 0, &ui);
		return true;
	}

	LRESULT OnPaint(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		SYSTEMTIME st;
		GetLocalTime(&st);
		TCHAR szCas[30];
/*		_stprintf(szCas, _T("%d:%.2d:%.2d"),
			st.wHour, st.wMinute, st.wSecond);*/
		swprintf_s(szCas, _countof(szCas), _T("%d:%.2d:%.2d"),
			st.wHour, st.wMinute, st.wSecond);
		RECT rect;
		GetClientRect(&rect);
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(&ps);
		DrawText(hdc, szCas, -1, &rect,
			DT_SINGLELINE | DT_CENTER | DT_VCENTER);
		EndPaint(&ps);
		return 0;
	}

	LRESULT OnTimer(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		RedrawWindow();
		return 0;
	}
};
