/****************************************************
Instaltor s registrac COM server
Soubor: Instalator.cpp
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#include "stdafx.h"
#include ".\instalator.h"
#include "resource.h"

// pomocn tda pro tlatka s vl. kurzorem
class Button : public CWindowImpl< Button >
{
public:
	DECLARE_WND_SUPERCLASS(L"MujButton", WC_BUTTON)
	bool kurzor;
public:
	BEGIN_MSG_MAP(RButton)
		MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

	LRESULT OnSetCursor(UINT, WPARAM, LPARAM, BOOL&)
	{
		SetCursor(LoadCursor(NULL, IDC_HAND));
		return 1;
	}
};

class Aplikace : public CAtlExeModuleT< Aplikace >,
	public CDialogImpl< Aplikace >

{
public:
	CString jmeno;
	Button btnKonec;
	Button btnInstalovat;
	Button btnZdroj;
	Button btnCil;
public :
DECLARE_LIBID(LIBID_ATLLib)
enum { IDD = IDD_HLAVNI };

BEGIN_MSG_MAP(Aplikace)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDC_VYBRAT_SLOZKU_ZDROJ,
		BN_CLICKED, OnVybratSlozkuZdroj)
	COMMAND_HANDLER(IDC_VYBRAT_SLOZKU_CIL,
		BN_CLICKED, OnVybratSlozkuCil)
	COMMAND_HANDLER(IDC_INSTALOVAT,
		BN_CLICKED, OnInstalovat)
	REFLECT_NOTIFICATIONS()
END_MSG_MAP()

LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
{
	SetIcon(LoadIcon(_AtlBaseModule.m_hInst,
		MAKEINTRESOURCE(IDI_HLAVNI)), TRUE);
	SetIcon((HICON)LoadImage(_AtlBaseModule.m_hInst,
		MAKEINTRESOURCE(IDI_HLAVNI),
		IMAGE_ICON, 16,16,0), FALSE);
	SetWindowText(jmeno);
	btnKonec.SubclassWindow(GetDlgItem(IDOK));
	btnInstalovat.SubclassWindow(
		GetDlgItem(IDC_INSTALOVAT));
	btnCil.SubclassWindow(
		GetDlgItem(IDC_VYBRAT_SLOZKU_CIL));
	btnZdroj.SubclassWindow(
		GetDlgItem(IDC_VYBRAT_SLOZKU_ZDROJ));
	
	CString slozka;
	GetSlozkaExe(slozka);
	SetDlgItemText(IDC_SLOZKA_ZDROJ, slozka);

	GetSlozkaProgramFiles(slozka);
	SetDlgItemText(IDC_SLOZKA_CIL, slozka);
	
	CheckDlgButton(IDC_ZASTUPCE_PLOCHA,
		BST_CHECKED);
	CheckDlgButton(IDC_ZASTUPCE_START,
		BST_CHECKED);
	EnableMenuItem(GetSystemMenu(FALSE),
		SC_CLOSE, FALSE);
	return 0;
}

LRESULT OnVybratSlozkuZdroj(WORD,
	WORD, HWND, BOOL&)
{
	CString text;
	GetDlgItemText(IDC_SLOZKA_ZDROJ, text);
	if (VybratSlozku(text,
		L"Vyberte zdrojovou sloku",
		m_hWnd))
		SetDlgItemText(IDC_SLOZKA_ZDROJ, text);
	return 0;
}

LRESULT OnVybratSlozkuCil(WORD,
	WORD, HWND, BOOL&)
{
	CString text;
	GetDlgItemText(IDC_SLOZKA_CIL, text);
	if (VybratSlozku(text,
		L"Vyberte clovou sloku",
		m_hWnd))
		SetDlgItemText(IDC_SLOZKA_CIL, text);
	return 0;
}

bool Instalace()
{
	Sleep(2000);
	wchar_t slozkaZdroj[MAX_PATH];
	wchar_t slozkaCil[MAX_PATH];
	GetDlgItemText(IDC_SLOZKA_ZDROJ,
		slozkaZdroj, MAX_PATH);
	GetDlgItemText(IDC_SLOZKA_CIL,
		slozkaCil, MAX_PATH);
	if (!PathFileExists(slozkaZdroj))
		return false;
	wcscat(slozkaCil, L"\\Demo aplikace");
	if (!PathFileExists(slozkaCil))
		if (!CreateDirectory(slozkaCil, NULL) )
			return false;
	CString strZdroj;
	CString strCil;

	strZdroj.Format(L"%s\\ImageAx.dll", slozkaZdroj);
	strCil.Format(L"%s\\ImageAx.dll", slozkaCil);
	if (!PathFileExists(strZdroj.GetBuffer()))
		return false;
	if (!CopyFile(strZdroj.GetBuffer(),
		strCil.GetBuffer(), FALSE))
		return false;
	if (!RegistrovatCom(strCil.GetBuffer()))
		return false;

	strZdroj.Format(L"%s\\ModulProcesy.dll", slozkaZdroj);
	strCil.Format(L"%s\\ModulProcesy.dll", slozkaCil);
	if (!PathFileExists(strZdroj.GetBuffer()))
		return false;
	if (!CopyFile(strZdroj.GetBuffer(),
		strCil.GetBuffer(), FALSE))
		return false;
	if (!RegistrovatCom(strCil.GetBuffer()))
		return false;
	
	strZdroj.Format(L"%s\\FontComboBoxAx.dll",
		slozkaZdroj);
	strCil.Format(L"%s\\FontComboBoxAx.dll",
		slozkaCil);
	if (!PathFileExists(strZdroj.GetBuffer()))
		return false;
	if (!CopyFile(strZdroj.GetBuffer(),
		strCil.GetBuffer(), FALSE))
		return false;
	if (!RegistrovatCom(strCil.GetBuffer()))
		return false;
	
	strZdroj.Format(L"%s\\ProhlizecObrazku.exe",
		slozkaZdroj);
	strCil.Format(L"%s\\ProhlizecObrazku.exe",
		slozkaCil);
	if (!PathFileExists(strZdroj.GetBuffer()))
		return false;
	if (!CopyFile(strZdroj.GetBuffer(),
		strCil.GetBuffer(), FALSE))
		return false;
	
	strZdroj.Format(L"%s\\DemoAplikace.exe",
		slozkaZdroj);
	strCil.Format(L"%s\\DemoAplikace.exe", slozkaCil);
	if (!PathFileExists(strZdroj.GetBuffer()))
		return false;
	if (!CopyFile(strZdroj.GetBuffer(),
		strCil.GetBuffer(), FALSE))
		return false;
	
	strCil.Format(L"%s\\ProhlizecObrazku.exe", slozkaCil);
	if (IsDlgButtonChecked(IDC_ZASTUPCE_PLOCHA))
	{
		if (!VytvoritZastupceNaPlose(strCil.GetBuffer(),
			L"Prohle obrzk",
			L"Jednoduch prohle obrzk"))
			return false;
	}
	if (IsDlgButtonChecked(IDC_ZASTUPCE_START))
	{
		if (!VytvoritZastupceStart(strCil.GetBuffer(),
			L"Prohle obrzk",
			L"Jednoduch prohle obrzk"))
			return false;
	}
	
	strCil.Format(L"%s\\DemoAplikace.exe", slozkaCil);
	if (IsDlgButtonChecked(IDC_ZASTUPCE_PLOCHA))
	{
		if (!VytvoritZastupceNaPlose(strCil.GetBuffer(),
			L"Demo aplikace",
			L"Jednoduch ukzkov aplikace"))
			return false;
	}
	if (IsDlgButtonChecked(IDC_ZASTUPCE_START))
	{
		if (!VytvoritZastupceStart(strCil.GetBuffer(),
			L"Demo aplikace",
			L"Jednoduch ukzkov aplikace"))
			return false;
	}

	return true;
}

LRESULT OnInstalovat(WORD, WORD, HWND, BOOL&)
{
	GetDlgItem(IDOK).EnableWindow(FALSE);
	EnableMenuItem(GetSystemMenu(FALSE),
		SC_CLOSE, MF_BYCOMMAND | MF_DISABLED);
	if (Instalace())
	{
		MessageBox(L"Instalace probhla spn",
			jmeno, MB_ICONINFORMATION);
	}
	else
	{
		MessageBox(L"Pi Instalaci dolo k chyb",
			jmeno, MB_ICONERROR);

	}
	GetDlgItem(IDOK).EnableWindow(TRUE);
	EnableMenuItem(GetSystemMenu(TRUE),
		SC_CLOSE, MF_BYCOMMAND | MF_DISABLED);
	SetWindowPos(NULL, 0, 0, 0, 0,
		SWP_NOZORDER | SWP_NOMOVE |
		SWP_NOSIZE | SWP_DRAWFRAME);
	return 0;
}

LRESULT OnKonec(WORD, WORD wID, HWND, BOOL&)
{
	EndDialog(wID);
	return 0;
}

bool RegistrovatCom(const wchar_t* pszSoubor,
	bool bRegistrovat = true)
{
	HMODULE hModule;
	hModule = LoadLibrary(pszSoubor);
	if (!hModule)
		return false;
	FARPROC pRegisterServer;
	if (bRegistrovat)
		pRegisterServer = GetProcAddress(
		hModule, "DllRegisterServer");
	else
		pRegisterServer = GetProcAddress(
		hModule, "DllUnregisterServer");
	if (!pRegisterServer)
	{
		if (!FreeLibrary(hModule))
			AtlThrowLastWin32();
		return false;
	}
	if ((*pRegisterServer)() != S_OK)
	{
		if (!FreeLibrary(hModule))
			AtlThrowLastWin32();
		return false;
	}
	if (!FreeLibrary(hModule))
		AtlThrowLastWin32();
	return true;		
};

bool GetSlozkaExe(CString& Slozka)
{
	wchar_t szCesta[MAX_PATH];
	if (GetModuleFileName(NULL, szCesta, MAX_PATH) == 0)
		return false;
	if (!PathRemoveFileSpec(szCesta))
		return false;
	Slozka = CString(szCesta);
	return true;
}

bool GetSlozkaProgramFiles(CString& strSlozka)
{
	if (!SUCCEEDED(SHGetFolderPath(NULL,
		CSIDL_PROGRAM_FILES, NULL, SHGFP_TYPE_CURRENT,
		strSlozka.GetBufferSetLength(MAX_PATH))))
		return false;
	else
	{
		strSlozka.ReleaseBuffer();
		return (PathFileExists(strSlozka.GetBuffer()) != FALSE);
	}
}

bool VytvoritZastupce(const wchar_t* pszCesta,
	const wchar_t* pszOdkaz,
	const wchar_t* pszPopis)
{
	HRESULT hres;
	IShellLink* psl;
	hres = CoCreateInstance(CLSID_ShellLink,
		NULL, CLSCTX_INPROC_SERVER,
	IID_IShellLink, (LPVOID*)&psl);
	if (hres != S_OK)
		return false;

	IPersistFile* ppf;
	hres = psl->QueryInterface(
		IID_IPersistFile, (LPVOID*)&ppf);
	if (hres != S_OK)
		return false;

	WORD wsz[MAX_PATH];
	hres = psl->SetPath(pszCesta);
	if (!SUCCEEDED(hres))
		return false;
		
	hres = psl->SetDescription(pszPopis);
	if (!SUCCEEDED(hres))
		return false;
		
	StringCbCopyW((wchar_t*)wsz, sizeof(wsz), pszOdkaz);
	hres = ppf->Save((wchar_t*)wsz, TRUE);
	ppf->Release();
	psl->Release();
	return (SUCCEEDED(hres));
}

bool VytvoritZastupceNaPlose(const wchar_t* pszCesta,
	const wchar_t* pszOdkaz, const wchar_t* pszPopis)
{
	wchar_t szDesktop[MAX_PATH];
	SHGetFolderPath(NULL,
		CSIDL_COMMON_DESKTOPDIRECTORY, NULL,
		SHGFP_TYPE_CURRENT, szDesktop);
	StringCbCat(szDesktop, sizeof(szDesktop), L"\\");
	StringCbCat(szDesktop, sizeof(szDesktop), pszOdkaz);
	StringCbCat(szDesktop, sizeof(szDesktop), L".lnk");
	return VytvoritZastupce(pszCesta, szDesktop, pszPopis);
}

bool VytvoritZastupcePoSpusteni(const wchar_t* pszCesta,
	const wchar_t* pszOdkaz, const wchar_t* pszPopis)
{
	wchar_t szStartup[MAX_PATH];
	SHGetFolderPath(NULL, CSIDL_STARTUP,
		NULL, SHGFP_TYPE_CURRENT, szStartup);
	StringCbCatW(szStartup, sizeof(szStartup), L"\\");
	StringCbCatW(szStartup, sizeof(szStartup), pszOdkaz);
	StringCbCatW(szStartup, sizeof(szStartup), L".lnk");
	return VytvoritZastupce(pszCesta, szStartup, pszPopis);
}

bool VytvoritZastupceStart(const wchar_t* pszCesta,
	const wchar_t* pszOdkaz, const wchar_t* pszPopis)
{
	wchar_t szStartup[MAX_PATH];
	SHGetFolderPath(NULL, CSIDL_COMMON_PROGRAMS,
		NULL, SHGFP_TYPE_CURRENT, szStartup);
	StringCbCatW(szStartup,
		sizeof(szStartup), L"\\");
	StringCbCatW(szStartup,
		sizeof(szStartup), pszOdkaz);
	StringCbCatW(szStartup,
		sizeof(szStartup), L".lnk");
	return VytvoritZastupce(pszCesta,
		szStartup, pszPopis);
}

static int CALLBACK BrowseCallbackProc(HWND hWnd,
	UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	wchar_t szDir[MAX_PATH];
	switch (uMsg)
	{
		case BFFM_INITIALIZED:
			if (lpData)
				::SendMessage(hWnd,
				BFFM_SETSELECTION,
				TRUE, (LPARAM)lpData);
			break;
		case BFFM_SELCHANGED:
			if (SHGetPathFromIDList(
				(LPITEMIDLIST)lParam, szDir))
				::SendMessage(hWnd,
				BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir);
			break;
	}
	return 0;
}

bool VybratSlozku(CString& rSlozka,
	const wchar_t* pszNadpis,
	HWND hVlastnik, bool rozsirenyDialog = false)
{
	wchar_t szStartBrowseDir[MAX_PATH];
	if (rSlozka.GetLength() > 0)
	{
		if (rSlozka.CompareNoCase(L"current") == 0)
			GetCurrentDirectory(
			sizeof(szStartBrowseDir)/sizeof(wchar_t),
			szStartBrowseDir);
		else
			StringCbCopyW(szStartBrowseDir,
			sizeof(szStartBrowseDir),
			rSlozka.GetBuffer());
	}
	bool bResult = true;
	LPITEMIDLIST pidl = NULL;
	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);
	if (hVlastnik)
		bi.hwndOwner = hVlastnik;
	else
		bi.hwndOwner = NULL;
	bi.pszDisplayName = 0;
	bi.pidlRoot = 0;
	bi.lParam = (LPARAM)szStartBrowseDir;
	if (rozsirenyDialog)
		bi.ulFlags = BIF_RETURNONLYFSDIRS 
		| BIF_NEWDIALOGSTYLE;
	else
		bi.ulFlags = BIF_RETURNONLYFSDIRS 
		| BIF_STATUSTEXT;
	bi.lpfn = BrowseCallbackProc;
	if (pszNadpis == NULL)
		bi.lpszTitle = L"Vyberte poadovanou sloku";
	else
		bi.lpszTitle = pszNadpis;
	pidl= SHBrowseForFolder(&bi);
	if (pidl)
	{
		if (!SHGetPathFromIDList(pidl,
			rSlozka.GetBufferSetLength(MAX_PATH)))
			bResult = FALSE;
		rSlozka.ReleaseBuffer();
		pMalloc->Free(pidl);
	}
	else
		bResult = false;
	pMalloc->Release();
	return bResult;
}

HRESULT PreMessageLoop(int nShowCmd)
{
	__super::PreMessageLoop(nShowCmd);
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES |
		ICC_USEREX_CLASSES | ICC_DATE_CLASSES |
		ICC_LISTVIEW_CLASSES | ICC_COOL_CLASSES |
		ICC_BAR_CLASSES | ICC_INTERNET_CLASSES |
        ICC_NATIVEFNTCTL_CLASS | ICC_TAB_CLASSES |
		ICC_ANIMATE_CLASS;
	if (!InitCommonControlsEx(&icc))
		return E_FAIL;
	Lock();
	if (!jmeno.LoadString(IDS_PROJNAME))
		return E_FAIL;
	DoModal();
	Unlock();
	return S_FALSE;
}

void ZobrazitPosledniChybu()
{
	DWORD dwPosledniChyba = GetLastError();
	if (dwPosledniChyba == 0) 
	{
		MessageBox(L"Dolo k nespecifikovan chyb",
			jmeno,
			MB_TASKMODAL | MB_SETFOREGROUND | MB_ICONERROR);
	}
	else
	{
		void* lpMessage = NULL;
		if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
			NULL, dwPosledniChyba,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(wchar_t*)&lpMessage, 0, NULL) == 0)
		{
			if (lpMessage)
				LocalFree(lpMessage);
			MessageBox(L"Dolo k nespecifikovan chyb",
				jmeno,
				MB_TASKMODAL | MB_SETFOREGROUND | MB_ICONERROR);
		}
		else
		{
			MessageBox((wchar_t*)lpMessage,
				jmeno,
				MB_TASKMODAL | MB_SETFOREGROUND | MB_ICONERROR);
			LocalFree(lpMessage);
		}
	}
}
};

Aplikace _AtlModule;

// hlavn funkce Win32 aprogramu
extern "C" int WINAPI _tWinMain(
	HINSTANCE, HINSTANCE, LPTSTR, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}


