#pragma once

namespace AtlDemo
{

class Aplikace
{
public:
	bool InitCommonControls()
	{
		INITCOMMONCONTROLSEX icc;
		icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC = ICC_WIN95_CLASSES | ICC_USEREX_CLASSES | ICC_DATE_CLASSES | ICC_LISTVIEW_CLASSES |
			ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_INTERNET_CLASSES |
			ICC_NATIVEFNTCTL_CLASS | ICC_TAB_CLASSES | ICC_ANIMATE_CLASS;
		return InitCommonControlsEx(&icc) ? true : false;
	}

	void ZobrazitPosledniChybu()
	{
		DWORD dwPosledniChyba = GetLastError();
		if (dwPosledniChyba == 0) 
		{
			MessageBox(NULL, L"Dolo k nespecifikovan chyb",
				L"Zvan chyba", MB_TASKMODAL | MB_SETFOREGROUND | MB_ICONERROR);
		}
		else
		{
			void* lpMessage = NULL;
			if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				NULL, dwPosledniChyba,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				(wchar_t*)&lpMessage, 0, NULL) == 0)
			{
				if (lpMessage)
					LocalFree(lpMessage);
				MessageBox(NULL, L"Dolo k nespecifikovan chyb",
					L"Zvan chyba", MB_TASKMODAL | MB_SETFOREGROUND | MB_ICONERROR);
			}
			else
			{
				MessageBox(NULL, (wchar_t*)lpMessage, L"Zvan chyba",
					MB_TASKMODAL | MB_SETFOREGROUND | MB_ICONERROR);
				LocalFree(lpMessage);
			}
		}
	}
};

/****************************************************
Vlastn button
Soubor: AtlDemo.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

class Button : public CWindowImpl< Button >
{
public:
	DECLARE_WND_SUPERCLASS(L"DemoButton", WC_BUTTON)
	bool kurzor;
public:
	BEGIN_MSG_MAP(RButton)
		MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

	LRESULT OnSetCursor(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		SetCursor(LoadCursor(NULL, IDC_HAND));
		return 1;
	}
};

/****************************************************
ComboBox zobrazujc seznam psem.
Kad poloka kreslena pslunm fontem
Soubor: AtlDemo.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

class ComboBoxFont : public CWindowImpl< ComboBoxFont >
{
public:
	static int CALLBACK EnumFontFamExProc(ENUMLOGFONTEX* lpelfe,
        NEWTEXTMETRICEX* lpntme,
        DWORD FontType,
        LPARAM lParam)
	{
		if( ((ComboBoxFont*)lParam)->trueType)
			if (FontType == RASTER_FONTTYPE)
				return 1;
		::SendMessage((HWND)((ComboBoxFont*)lParam)->m_hWnd,
			CB_ADDSTRING,0, (LPARAM)lpelfe->elfFullName);
		return 1;
	}

public:
	DECLARE_WND_SUPERCLASS(L"ComboBoxFont", WC_COMBOBOX)
	bool trueType;
	BYTE charSet;

public:
	BEGIN_MSG_MAP(ComboBoxFormatBitmapy)
		MESSAGE_HANDLER(OCM_DRAWITEM, OnDrawItem)
		MESSAGE_HANDLER(OCM_MEASUREITEM, OnMeasureItem)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

	ComboBoxFont()
	{
		trueType = true;
		charSet = 0;
	}

	int Nastavit(HWND hwnd, bool trueType = true, BYTE charSet = 0)
	{
		if (!::IsWindow(hwnd))
			throw E_INVALIDARG;
		if (IsWindow())
			UnsubclassWindow();
		if (!SubclassWindow(hwnd))
			AtlThrowLastWin32();
		this->trueType = trueType;
		this->charSet = charSet;
		return Naplnit();
	}

	void GetText(int nIndex, CString& text)
	{
		LRESULT delka = SendMessage(CB_GETLBTEXTLEN, nIndex);
		if (delka == CB_ERR)
			return;
		if (SendMessage(CB_GETLBTEXT, (WPARAM)nIndex,
			(LPARAM)text.GetBufferSetLength((int)delka))
			== CB_ERR)
		{
			text.ReleaseBuffer();
			return;
		}
		else
			text.ReleaseBuffer();
	}

	LRESULT OnMeasureItem(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		((MEASUREITEMSTRUCT*)lParam)->itemHeight = 26;
		return 0;
	}

	LRESULT OnDrawItem(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		CString text;
		GetText(((DRAWITEMSTRUCT*)lParam)->itemID, text);
		HBRUSH hbPozadi;
		if (((DRAWITEMSTRUCT*)lParam)->itemState & ODS_SELECTED)
		{
			hbPozadi = GetSysColorBrush(COLOR_HIGHLIGHT);
			SetTextColor(((DRAWITEMSTRUCT*)lParam)->hDC,
				GetSysColor(COLOR_HIGHLIGHTTEXT));
		}
		else
		{
			hbPozadi = GetSysColorBrush(COLOR_WINDOW);
			SetTextColor(((DRAWITEMSTRUCT*)lParam)->hDC,
				GetSysColor(COLOR_WINDOWTEXT));
		}
		SetBkMode(((DRAWITEMSTRUCT*)lParam)->hDC, TRANSPARENT);
		FillRect(((DRAWITEMSTRUCT*)lParam)->hDC,
			&((DRAWITEMSTRUCT*)lParam)->rcItem,
			hbPozadi);
		((DRAWITEMSTRUCT*)lParam)->rcItem.left += 6;
		LOGFONT logfont;
		GetObject(GetStockObject(DEFAULT_GUI_FONT),
			sizeof(logfont), &logfont);
		lstrcpy(logfont.lfFaceName, text.GetBuffer());
		logfont.lfHeight = 20;
		HFONT hFont = CreateFontIndirect(&logfont);
		HFONT hfOrig = 
			(HFONT)SelectObject(((DRAWITEMSTRUCT*)lParam)->hDC,
			hFont);
		DrawText(((DRAWITEMSTRUCT*)lParam)->hDC,
			text.GetBuffer(), -1,
			&((DRAWITEMSTRUCT*)lParam)->rcItem,
			DT_SINGLELINE | DT_VCENTER);
		SelectObject(((DRAWITEMSTRUCT*)lParam)->hDC, hfOrig);
		if (!DeleteObject(hFont))
			AtlThrowLastWin32();
		return 0;
	}

	int Naplnit()
	{
		if (!IsWindow())
			return -1;
		SendMessage(CB_RESETCONTENT);
		SetRedraw(FALSE);
		HDC hdc = GetDC();
		LOGFONT logfont;
		memset(&logfont, 0, sizeof(logfont));
		logfont.lfCharSet = this->charSet;
		EnumFontFamiliesEx(hdc, &logfont,
			(FONTENUMPROC)EnumFontFamExProc,
			(LPARAM)this, 0);
		ReleaseDC(hdc);
		if (SendMessage(CB_GETCOUNT) > 0)
			SendMessage(CB_SETCURSEL, 0);
		SetRedraw(TRUE);
		return (int)SendMessage(CB_GETCOUNT);
	}

	int SetCharSet(BYTE charSet)
	{
		if (IsWindow())
		{
			this->charSet = charSet;
			return Naplnit();
		}
		else
			return -1;
	}

	int SetTrueType(bool trueType)
	{
		if (IsWindow())
		{
			this->trueType = trueType;
			return Naplnit();
		}
		else
			return -1;
	}
};

/****************************************************
Tda StatusBar
Soubor: AtlDemo.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

class StatusBar : public CWindow
{
public:
	StatusBar()
	{
	}

	bool Vytvorit(HWND hParent, UINT id = 1,
		DWORD plusStyl = 0)
	{
		RECT rect = {0, 0, 0, 0};
		plusStyl |= (WS_CHILD | WS_VISIBLE);
		if (!Create(STATUSCLASSNAMEW,
			hParent, rect, L"", plusStyl, 0, id))
			AtlThrowLastWin32();
		return true;
	}

	~StatusBar()
	{
		if (IsWindow())
			if (!DestroyWindow())
				AtlThrowLastWin32();
		m_hWnd = NULL;
	}

	void SetJednoduchy(bool jednoduchy)
	{
		SendMessage(SB_SIMPLE, (WPARAM)jednoduchy);	
	}

	void SetCasti(int* pozice, int pocet)
	{
		if (!SendMessage(SB_SETPARTS,
			(WPARAM)pocet, (LPARAM)pozice))
			AtlThrowLastWin32();
	}

	void SetIkona(HICON hIcon, int cast)
	{
		if (!SendMessage(SB_SETICON,
			(WPARAM)cast, (LPARAM)hIcon))
			AtlThrowLastWin32();
	}

	void SetText(const wchar_t* text, int cast)
	{
		if (cast >= 0)
		{
			if (!SendMessage(SB_SETTEXT,
				(WPARAM)cast, (LPARAM)text))
				AtlThrowLastWin32();
		}
		else
		{
			if (!SendMessage(SB_SETTEXT,
				(WPARAM)SB_SIMPLEID, (LPARAM)text))
				AtlThrowLastWin32();
		}
	}
};

/****************************************************
Tda ToolBar
Soubor: AtlDemo.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

enum ToolBarStrana
{
	toolBarNahore,
	toolBarVpravo,
	toolBarDole,
	toolBarVlevo
};

class ToolBar : public CWindow
{
public:
	~ToolBar()
	{
		if (IsWindow())
			if (!DestroyWindow())
				AtlThrowLastWin32();
	}

	bool PridatTlacitko(int nPrikaz,
		int nBmpIndex,
		const wchar_t* text = NULL,
		BYTE bState = (BYTE)TBSTATE_ENABLED,
		BYTE bStyle = (BYTE)(TBSTYLE_BUTTON |
			TBSTYLE_TOOLTIPS | TBSTYLE_FLAT |
			TBSTYLE_WRAPABLE),
		DWORD_PTR dwData = 0)
	{
		TBBUTTON tbb;
		ZeroMemory(&tbb, sizeof(TBBUTTON));
		tbb.iBitmap = nBmpIndex;
		tbb.idCommand = nPrikaz;
		tbb.fsState = bState;
		tbb.fsStyle = bStyle;
		tbb.dwData = dwData;
		tbb.iString = (INT_PTR)text;
		return (SendMessage(TB_INSERTBUTTON,
			-1, (LPARAM)&tbb) != 0);
	}

	void PovolitTlacitko(UINT uID, bool povolit)
	{
		SendMessage(TB_ENABLEBUTTON,
			uID, (LPARAM)povolit);
	}

	bool PridatOddelovac()
	{
		TBBUTTON tbb;
		ZeroMemory(&tbb, sizeof(TBBUTTON));
		tbb.iBitmap = 0;
		tbb.idCommand = 0;
		tbb.fsState = (BYTE)
			(TBSTATE_ENABLED | TBSTYLE_WRAPABLE);
		tbb.fsStyle = (BYTE)(TBSTYLE_SEP);
		tbb.dwData = 0;
		tbb.iString = (INT_PTR)L"";
		return (SendMessage(TB_INSERTBUTTON,
			-1, (LPARAM)&tbb) != 0);
	}

	bool Zaskrtnout(UINT uID, bool bCheck)
	{
		return (SendMessage(TB_CHECKBUTTON,
			uID, MAKELONG((BOOL)bCheck, 0)) != 0);
	}

	bool GetPovoleni(UINT uID)
	{
		return (SendMessage(TB_ISBUTTONENABLED, uID)
			!= 0);
	}
	
	bool GetZaskrtnuti(UINT uID)
	{
		return (SendMessage(TB_ISBUTTONCHECKED, uID)
			!= 0);
	}
	
	bool Vytvorit(HWND hParent,
			HIMAGELIST hImageList,
			ToolBarStrana strana = toolBarNahore,
			UINT uID = 0,
			DWORD dwStyl = WS_CHILD | WS_VISIBLE |
				CCS_ADJUSTABLE |TBSTYLE_TOOLTIPS |
				TBSTYLE_TRANSPARENT |
				TBSTYLE_CUSTOMERASE)
	{
		if (IsWindow())
			if (!DestroyWindow())
				AtlThrowLastWin32();
		RECT rect = {0,0,0,0};
		switch (strana)
		{
		case toolBarDole:
			dwStyl |= CCS_BOTTOM;
			break;
		case toolBarNahore:
			dwStyl |= CCS_TOP;
			break;
		case toolBarVlevo:
			dwStyl |= (CCS_LEFT |
				CCS_VERT | TBSTYLE_WRAPABLE);
			break;
		case toolBarVpravo:
			dwStyl |= (CCS_RIGHT |
				CCS_VERT | TBSTYLE_WRAPABLE);
			break;
		}
		if (!Create(TOOLBARCLASSNAME, hParent,
			&rect, NULL, dwStyl, 0, uID))
			return false;
		SendMessage(TB_BUTTONSTRUCTSIZE,
			(WPARAM) sizeof(TBBUTTON), 0);
		SendMessage(TB_SETIMAGELIST, 0,
			(LPARAM)hImageList);
		return true;
	}
};

};
