/****************************************************
Soubor: MediaPrehravac.cpp
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#include "stdafx.h"
#include "resource.h"

class DlgUrl : 
	public CDialogImpl< DlgUrl >
{
public:
	enum { IDD = IDD_URL };
	AtlDemo::Button btnOK;
	AtlDemo::Button btnStorno;
	CString strUrl;

BEGIN_MSG_MAP(DlgVlastnostiStranky)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnZavrit)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnZavrit)
	REFLECT_NOTIFICATIONS()
END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		strUrl = L"http://www.totalcountry103.com"
			L"/listen/totalcountry.asx";
		btnOK.SubclassWindow(GetDlgItem(IDOK));
		btnStorno.SubclassWindow(GetDlgItem(IDCANCEL));
		SetDlgItemText(IDC_URL, strUrl);
		return 1;
	}

	LRESULT OnZavrit(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		if (wID == IDOK)
			GetDlgItemText(IDC_URL, strUrl);
		EndDialog(wID);
		return 0;
	}
};


class Aplikace : public CAtlExeModuleT< Aplikace >,
		public AtlDemo::Aplikace,
		public CWindowImpl< Aplikace >,
		public IDispEventImpl< IDC_MEDIAPLAYER, Aplikace >
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
					CS_DBLCLKS,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),
				(HCURSOR)NULL,
				(HBRUSH)GetSysColorBrush(COLOR_WINDOW),
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				_T("MediaPrehravacHlavni"),
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI))
			},
			NULL,
			NULL, // wndproc
			IDC_CROSS, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}

public:
	CString strInfo;
	AtlDemo::StatusBar* statusBar;
	CAxWindow2 axWindowMP;
	IWMPPlayer4* wmpPlayer;
	IWMPMedia* wmpMedia;
	IWMPNetwork* wmpNetwork;
	IWMPSettings* wmpSettings;
	bool timerBufferingAktivni;
	CString jmeno;

public:
	DECLARE_LIBID(LIBID_ATLLib)

	Aplikace()
	{
		timerBufferingAktivni = false;
	}

	BEGIN_MSG_MAP(Aplikace)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
		COMMAND_ID_HANDLER(ID_OTEVRIT_SOUBOR,
			OnOtevritSoubor)
		COMMAND_ID_HANDLER(ID_OTEVRIT_URL, OnOtevritUrl)
		COMMAND_ID_HANDLER(ID_ZOBRAZIT_PREHRAVAC,
			OnZobrazitPrehravac)
			REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

	BEGIN_SINK_MAP(Aplikace)
		SINK_ENTRY(IDC_MEDIAPLAYER,
			DISPID_WMPCOREEVENT_BUFFERING,
			OnBuffering)
		SINK_ENTRY(IDC_MEDIAPLAYER,
			DISPID_WMPCOREEVENT_PLAYSTATECHANGE,
			OnPlayStateChange)
	END_SINK_MAP()

	HRESULT PreMessageLoop(int nShowCmd)
	{
		CAtlExeModuleT<Aplikace>::PreMessageLoop(nShowCmd);
		if (!InitCommonControls())
			return E_FAIL;
		if (!jmeno.LoadString(IDS_PROJNAME))
			return E_FAIL;
		Lock();
		if (!Vytvorit())
			return E_FAIL;
		return S_OK;
	}

	HRESULT PostMessageLoop()
	{
		Unlock();
		return __super::PostMessageLoop();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnClose(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		AtlAdviseSinkMap(this, false);
		if (axWindowMP.IsWindow())
			if (!axWindowMP.DestroyWindow())
				AtlThrowLastWin32();
		return DefWindowProc();
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnOtevritSoubor(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		wchar_t soubor[MAX_PATH] = {0};
		if (!wmpPlayer)
			return 0;
		CComBSTR bstrURL;
		wmpPlayer->get_URL(&bstrURL);
		if (PathFileExists(bstrURL.m_str))
			wcscpy(soubor, bstrURL.m_str);
		OPENFILENAME ofn;
		memset(&ofn, 0, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.nMaxFile = MAX_PATH;
		ofn.lpstrFile = soubor;
		ofn.hwndOwner = m_hWnd;
		ofn.lpstrFilter =
			L"Soubory Windows Media (*.wma,wmv)\0"
			L"*.wma;*.wmv\0"
			L"Vechny soubory\0*.*\0";
		ofn.nFilterIndex = 1;
		if (!GetOpenFileName(&ofn))
			return 0;
		wmpPlayer->put_URL(soubor);
		return 0;
	}

	LRESULT OnOtevritUrl(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		DlgUrl dlg;
		if (dlg.DoModal() == IDOK)
			wmpPlayer->put_URL(dlg.strUrl.GetBuffer());
		return 0;
	}

	LRESULT OnZobrazitPrehravac(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (axWindowMP.IsWindowVisible())
		{
			wmpPlayer->put_uiMode(L"none");
			axWindowMP.ShowWindow(SW_HIDE);
			CheckMenuItem(GetMenu(),
				ID_ZOBRAZIT_PREHRAVAC,
				MF_UNCHECKED);
		}
		else
		{
			wmpPlayer->put_uiMode(L"full");
			axWindowMP.ShowWindow(SW_RESTORE);
			CheckMenuItem(GetMenu(),
				ID_ZOBRAZIT_PREHRAVAC,
				MF_CHECKED);
		}
		RedrawWindow();
		return 0;
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		RECT rectSB = {0, 0, 0, 0};
		if (this->statusBar)
		{
			statusBar->SendMessage(uMsg, wParam, lParam);
			statusBar->GetWindowRect(&rectSB);
		}
		if (axWindowMP.IsWindow())
			axWindowMP.SetWindowPos(NULL,
			0, 0,
			LOWORD(lParam),
			HIWORD(lParam) -
				(rectSB.bottom - rectSB.top),
			SWP_NOZORDER);
		return DefWindowProc();
	}

	LRESULT OnTimer(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		long bufferingProgress;
		switch (wParam)
		{
		case 1:
			if (wmpNetwork->get_bufferingProgress(
				&bufferingProgress) == S_OK)
			{
				strInfo.Format(
					L"Nateno do bufferu: %d procent",
					(int)bufferingProgress);
				if (this->statusBar)
					statusBar->SetText(strInfo, 0);
			}
			break;
		}
		return 0;
	}

	void SetStatusText(const wchar_t* text = NULL)
	{
		if (text)
			strInfo = CString(text);
		if (statusBar)
			statusBar->SetText(strInfo.GetBuffer(), 0);
	}

	bool Vytvorit()
	{
		strInfo.LoadString(IDS_PRIPRAVEN);
		RECT rect = {0, 0, 800, 600};
		if (!Create(NULL, &rect, jmeno,
			WS_OVERLAPPEDWINDOW))
			return false;
		statusBar = new AtlDemo::StatusBar();
		statusBar->Vytvorit(m_hWnd);
		SetStatusText();

		HRESULT hr;
		axWindowMP.Create(m_hWnd, &rect, NULL, WS_CHILD,
			0, IDC_MEDIAPLAYER);
		hr = axWindowMP.CreateControl(L"WMPlayer.OCX");
		if (FAILED(hr))
			return false;
		hr = axWindowMP.QueryControl(&wmpPlayer);
		if (FAILED(hr))
			return false;
		hr = wmpPlayer->get_network(&wmpNetwork);
		if (FAILED(hr))
			return false;
		hr = wmpPlayer->get_settings(&wmpSettings);
		if (FAILED(hr))
			return false;

		axWindowMP.SetWindowPos(NULL,
			0, 0, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
		wmpPlayer->put_uiMode(L"full");
		hr = AtlAdviseSinkMap(this, true);
		if (FAILED(hr))
			return false;
		CenterWindow();
		axWindowMP.ShowWindow(SW_SHOW);
		CheckMenuItem(GetMenu(),
			ID_ZOBRAZIT_PREHRAVAC, MF_CHECKED);
		ShowWindow(SW_SHOW);
		UpdateWindow();
		return true;
	}

	void __stdcall OnBuffering(VARIANT_BOOL start)
	{
		if (start == VARIANT_FALSE)
		{
			if (timerBufferingAktivni)
			{
				if (!KillTimer(1))
					AtlThrowLastWin32();
				timerBufferingAktivni = false;
			}
			if (!strInfo.LoadString(IDS_PRIPRAVEN))
				throw 0;
			if (this->statusBar)
				statusBar->SetText(strInfo, 0);
		}
		else
		{
			if (!timerBufferingAktivni)
			{
				if (!SetTimer(1, 100))
					AtlThrowLastWin32();
				timerBufferingAktivni = true;
			}
		}
	}

	void __stdcall OnPlayStateChange(int stav)
	{
		switch (stav)
		{
		case 1:
			strInfo = L"Zastaveno";
			break;
		case 2:
			strInfo = L"Perueno";
			break;
		case 3:
			strInfo = L"Pehrvn";
			break;
		case 6:
			strInfo = L"Natn do bufferu...";
			break;
		case 7:
			strInfo = L"ekn";
			break;
		case 8:
			strInfo = L"Konec vysln";
			break;
		case 9:
			strInfo = L"Pipravuji data";
			break;
		case 10:
			strInfo = L"Pipraven k pehrvn";
			break;
		case 11:
			strInfo = L"Znovu pipojuji k vysln";
			break;
		}
		if (this->statusBar)
			statusBar->SetText(strInfo, 0);
	}
};

Aplikace _aplikace;

extern "C" int WINAPI _tWinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
    LPTSTR lpCmdLine, int nShowCmd)
{
    return _aplikace.WinMain(nShowCmd);
}
