#define STRICT
#define WINVER 0x0500
#define _WIN32_WINNT 0x0500
#define _WIN32_WINDOWS 0x0410
#define _WIN32_IE 0x0500

#define _ATL_APARTMENT_THREADED
#define _ATL_NO_AUTOMATIC_NAMESPACE
#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS
#define _ATL_ALL_WARNINGS

#define _ATL_NO_COM_SUPPORT
#define _INC_WINDOWSX

#include <atlbase.h>
#include <atlcom.h>
#include <atlcoll.h>
#include <atlwin.h>
#include <atltypes.h>
#include <atlctl.h>
using namespace ATL;

class Minimal : public CAtlExeModuleT< Minimal >,
	public CWindowImpl< Minimal >
{
public :
	DECLARE_LIBID(LIBID_ATLLib)
	BEGIN_MSG_MAP(Minimal)
		MESSAGE_HANDLER(WM_DESTROY, OnZpravaWindows)
		MESSAGE_HANDLER(WM_PAINT, OnZpravaWindows)
	END_MSG_MAP()

	LRESULT OnZpravaWindows(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		static PAINTSTRUCT ps;
		static RECT rect;
		HDC hdc;
		switch (uMsg)
		{
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_PAINT:
			GetClientRect(&rect);
			hdc = BeginPaint(&ps);
			DrawText(hdc, _T("Ahoj ATL"), -1, &rect,
				DT_SINGLELINE | DT_CENTER | DT_VCENTER);
			EndPaint(&ps);
			return 0;
		}
		return DefWindowProc();
	}

	HRESULT PreMessageLoop(int nShowCmd)
	{
		CAtlExeModuleT<Minimal>::PreMessageLoop(nShowCmd);
		RECT rect = {0, 0, 600, 450};
		if (!Create(NULL, &rect, _T("Minimal"),
			WS_OVERLAPPEDWINDOW))
			return S_FALSE;
		CenterWindow();
		ShowWindow(SW_SHOW);
		return S_OK;
	}
};

Minimal _AtlModule;

extern "C" int WINAPI _tWinMain(HINSTANCE hInstance,
								HINSTANCE hPrevInstance, 
                                LPTSTR lpCmdLine, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}

