/****************************************************
Projekt: OknoFormular
Soubor: DlgHlavni.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"

class DlgHlavni : public CDialogImpl<DlgHlavni>
{
public:
	DlgHlavni()
	{
	}

	~DlgHlavni()
	{
		if (IsWindow())
			if (!DestroyWindow())
				AtlThrowLastWin32();
	}

	enum { IDD = IDD_DLGHLAVNI };
	AtlDemo::ComboBoxFont cbFont;
	AtlDemo::Button btnKonec;

BEGIN_MSG_MAP(DlgHlavni)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDC_KONEC, BN_CLICKED, OnKonec)
	COMMAND_HANDLER(IDC_PISMA_ANSI, BN_CLICKED, OnSeznamFontu)
	COMMAND_HANDLER(IDC_PISMA_EE, BN_CLICKED, OnSeznamFontu)
	COMMAND_HANDLER(IDC_PISMA_SYMBOL, BN_CLICKED, OnSeznamFontu)
	REFLECT_NOTIFICATIONS()
END_MSG_MAP()


	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		int pocet = cbFont.Nastavit(GetDlgItem(IDC_SEZNAM_FONTU),
			true, SYMBOL_CHARSET);
		if (pocet >= 0)
			SetDlgItemInt(IDC_POCET_FONTU, pocet, FALSE);
		else
			SetDlgItemText(IDC_POCET_FONTU, _T("???"));
		btnKonec.SubclassWindow(GetDlgItem(IDC_KONEC));
		CheckDlgButton(IDC_PISMA_TT, BST_CHECKED);
		return 1;
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		GetParent().PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnSeznamFontu(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		BYTE charSet = 0;
		switch (wID)
		{
		case IDC_PISMA_ANSI:
			charSet = ANSI_CHARSET;
			break;
		case IDC_PISMA_EE:
			charSet = EASTEUROPE_CHARSET;
			break;
		case IDC_PISMA_SYMBOL:
			charSet = SYMBOL_CHARSET;
			break;
		}
		int pocet= cbFont.Nastavit(GetDlgItem(IDC_SEZNAM_FONTU),
			IsDlgButtonChecked(IDC_PISMA_TT) == BST_CHECKED,
			charSet);
		if (pocet >= 0)
			SetDlgItemInt(IDC_POCET_FONTU, pocet, FALSE);
		else
			SetDlgItemText(IDC_POCET_FONTU, _T("???"));
		return 0;
	}
};
