/****************************************************
Projekt: OknoFormular
Soubor: OknoHlavni.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include "DlgHlavni.h"

class OknoHlavni : public CWindowImpl< OknoHlavni >
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),// ikona
				(HCURSOR)NULL,
				(HBRUSH)NULL,
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				_T("MojeHlavniOkno"),
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)) // mal ikona
			},
			NULL,
			NULL, // wndproc
			IDC_CROSS, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}

public:
	DlgHlavni* dlgHlavni;

public:
	OknoHlavni()
	{
		dlgHlavni = NULL;
	}

	~OknoHlavni()
	{
		if (dlgHlavni)
			delete dlgHlavni;
	}

	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
	END_MSG_MAP()

	bool Vytvorit()
	{
		RECT rect = {0, 0, 400, 270};
		if (!Create(NULL, &rect, _T("Formul"),
			WS_OVERLAPPED | WS_SYSMENU |
			WS_BORDER | WS_MINIMIZEBOX))
			return false;
		dlgHlavni = new DlgHlavni();
		dlgHlavni->Create(m_hWnd);
		dlgHlavni->SetWindowPos(NULL,
			0, 0, 0,0,
			SWP_NOZORDER | SWP_NOSIZE);
		dlgHlavni->GetClientRect(&rect);
		AdjustWindowRectEx(&rect,
			WS_OVERLAPPED | WS_CAPTION | WS_BORDER,
			TRUE, 0);
		dlgHlavni->ShowWindow(SW_SHOW);
		SetWindowPos(NULL,
			0, 0,
			rect.right - rect.left,
			rect.bottom - rect.top,
			SWP_NOZORDER | SWP_NOMOVE);
		CenterWindow();
		ShowWindow(SW_SHOW);
		return true;
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}
};
