/****************************************************
Vlastn panel nstroj Internet Exploreru
Soubor: Panelt.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include "PanelNastrojuIE.h"

class DlgHlavni :
	public CDialogImpl<DlgHlavni>
{
public:
	DlgHlavni()
	{
	}

	~DlgHlavni()
	{
		if (IsWindow())
			DestroyWindow();
	}

	enum { IDD = IDD_HLAVNI };

BEGIN_MSG_MAP(DlgHlavni)
	MESSAGE_HANDLER(WM_COMMAND, OnCommand)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
END_MSG_MAP()

	LRESULT OnCommand(UINT, WPARAM wParam, LPARAM lParam, BOOL&)
	{
		::PostMessage(GetParent().m_hWnd, WM_COMMAND,
			wParam, lParam);
		return 0;
	}

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
		SendDlgItemMessage(IDC_COMBO_HISTORIE,
			CB_SETDROPPEDWIDTH, (WPARAM)450);
		return 1;
	}
};

// Panel
class ATL_NO_VTABLE Panel : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Panel, &CLSID_PanelIE>,
	public IObjectWithSiteImpl< Panel >,
	public IDeskBand,
	public IPersistStream,
	public CWindowImpl< Panel >,
	public IDispEventImpl<0, Panel,
		&__uuidof(DWebBrowserEvents2), &LIBID_SHDocVw, 1, 0>,
	public IDispatchImpl<IPanelIE, &IID_IPanelIE,
		&LIBID_PanelNastrojuIELib, 1, 0>
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)NULL,
				(HCURSOR)NULL,
				(HBRUSH)GetSysColorBrush(COLOR_3DFACE),
				NULL, // menu
				L"MujPanelIEClass",
				(HICON)NULL
			},
			NULL, // origname
			NULL, // wndproc
			IDC_ARROW, // cursor ID
			TRUE, // system cursor
			0, // atom
			L""
		};
		return wc;
	}

	static const int minVelikostX = 180;
	static const int minVelikostY = 22;
	static const int maxVelikostY = 25;

public:
	HWND hwndParent;
	DWORD dwBandID;
	DWORD dwViewMode;
	IInputObjectSite* inputObjectSite;
	CComPtr< IWebBrowser2 > webBrowser2;
	DlgHlavni* dlgHlavni;
	CWindow cbHistorie;

	typedef IDispEventImpl<0, Panel,
		&__uuidof(DWebBrowserEvents2),
		&LIBID_SHDocVw, 1, 0> tDispEvent;

public:
	Panel()
	{
		dlgHlavni = NULL;
		hwndParent = NULL;
		dwBandID = 0;
		dwViewMode = 0;
		inputObjectSite = NULL;
		webBrowser2 = NULL;
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_PANELIE)
	DECLARE_PROTECT_FINAL_CONSTRUCT()

	BEGIN_COM_MAP(Panel)
		COM_INTERFACE_ENTRY(IPanelIE)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(IDeskBand)
		COM_INTERFACE_ENTRY2(IOleWindow, IDeskBand)
		COM_INTERFACE_ENTRY2(IDockingWindow, IDeskBand)
		COM_INTERFACE_ENTRY(IObjectWithSite)
	END_COM_MAP()

	BEGIN_SINK_MAP(Panel) 
		SINK_ENTRY_EX(0,
			(__uuidof(DWebBrowserEvents2)),
			0x000000fa, BeforeNavigate2)
	END_SINK_MAP()

	BEGIN_MSG_MAP(Panel)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		COMMAND_HANDLER(IDC_INFO, BN_CLICKED, OnInfo)
		COMMAND_HANDLER(IDC_PRIDAT_DO_HISTORIE,
			BN_CLICKED, OnPridatDoHistorie)
		COMMAND_HANDLER(IDC_VYMAZAT_HISTORII,
			BN_CLICKED, OnVymazatHistorii);
		COMMAND_HANDLER(IDC_OBRAZKY,
			BN_CLICKED, OnObrazky);
		COMMAND_ID_HANDLER(ID_OBRAZKY_SKRYT,
			OnObrazkySkryt);
		COMMAND_ID_HANDLER(ID_OBRAZKY_ULOZIT,
			OnObrazkyUlozit);
		COMMAND_HANDLER(IDC_COMBO_HISTORIE,
			CBN_SELCHANGE, OnZmenaVyberuHistore)
	END_MSG_MAP()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
		cbHistorie.Detach();
		if (dlgHlavni)
			delete dlgHlavni;
		if (IsWindow())
			DestroyWindow();
	}

	// IOleWindow
	STDMETHOD (ContextSensitiveHelp) (BOOL)
	{
		return S_OK;
	}

	// IPersist
	STDMETHOD (GetClassID)(CLSID* pClassID)
	{
		*pClassID = CLSID_PanelIE;
		return S_OK;
	}

	STDMETHOD (GetWindow) (HWND* phWnd)
	{
		if ( !phWnd )
			return E_INVALIDARG;
		if ( IsWindow() )
			*phWnd = m_hWnd;
		return S_OK;
	}

	// IDockingWindow
	STDMETHOD (ShowDW) (BOOL bShow)
	{
		if (IsWindow())
		{
			if (bShow)
				ShowWindow(SW_SHOW);
			else
				ShowWindow(SW_HIDE);
		}
		return S_OK;
	}

	// IDockingWindow
	STDMETHOD (CloseDW) (DWORD dwReserved)
	{
		return S_OK;
	}

	// IPersistStream
	STDMETHOD (GetSizeMax)(ULARGE_INTEGER* pcbSize)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (IsDirty)()
	{
		return S_FALSE;
	}

	STDMETHOD (Load)(IStream* pStm)
	{
		return S_OK;
	}

	STDMETHOD (Save)(IStream* pStm, BOOL bClearDirty)
	{
		return S_OK;
	}

	// IDockingWindow
	STDMETHOD (ResizeBorderDW) (LPCRECT prcBorder, IUnknown* punkToolbarSite, BOOL bReserved)
	{
		return E_NOTIMPL;
	}

	// IObjectWithSite
	STDMETHOD(GetSite)(REFIID riid, void **ppvSite)
	{
		*ppvSite = NULL;
		if (inputObjectSite)
			return inputObjectSite->QueryInterface(riid, ppvSite);
		else
			return E_FAIL;
	}

	STDMETHOD(SetSite)(IUnknown* pUnkSite)
	{
		if (inputObjectSite)
		{
			inputObjectSite->Release();
			inputObjectSite = NULL;
		}
		if (pUnkSite)
		{
			IOleWindow  *pOleWindow = NULL;
			this->hwndParent = NULL;
			if (SUCCEEDED(pUnkSite->QueryInterface(
				IID_IOleWindow, (LPVOID*)&pOleWindow)))
			{
				pOleWindow->GetWindow(&this->hwndParent);
				pOleWindow->Release();
			}
			if (!::IsWindow(hwndParent))
					return E_FAIL;
				
			if (!VytvoritOkno())
				return E_FAIL;

			HRESULT hRes = pUnkSite->QueryInterface(
				IID_IInputObjectSite,
				(void**)&inputObjectSite);
			if (hRes != S_OK)
				return E_FAIL;
			if (!webBrowser2)
			{
				CComQIPtr<IServiceProvider> spSP(inputObjectSite);
				if ( spSP )
				{
					hRes = spSP->QueryService(
						__uuidof(IWebBrowserApp),
						__uuidof(IWebBrowser2),
						(void**)&webBrowser2);
					if ( hRes != S_OK )
						::MessageBox(NULL,
						L"Chyba zskn IE", NULL, NULL);
					tDispEvent::DispEventAdvise(webBrowser2);
				}
				else
					return E_FAIL;
			}
			return S_OK;
		}
		else
		{
			if (webBrowser2)
				tDispEvent::DispEventUnadvise(webBrowser2);	
		}
		return S_OK;
	}


	bool VytvoritOkno()
	{
		if (IsWindow())
			return false;
		if (!::IsWindow(hwndParent))
			return false;
		RECT rect = { 0, 0, 200, 75 };
		::GetClientRect(hwndParent, &rect);
		if ( !Create(hwndParent, rect, L"MujPanelIE",
			WS_CHILD| WS_VISIBLE, 0))
				return false;
		dlgHlavni = new DlgHlavni();
		dlgHlavni->Create(m_hWnd);
		dlgHlavni->ShowWindow(SW_SHOW);
		cbHistorie.Attach(dlgHlavni->GetDlgItem(
			IDC_COMBO_HISTORIE).m_hWnd);
		return true;
	}

	// IDeskBand
	STDMETHOD(GetBandInfo)(DWORD dwBandID,
		DWORD dwViewMode, DESKBANDINFO* pdbi)
	{
		if (pdbi)
		{
			this->dwBandID = dwBandID;
			this->dwViewMode = dwViewMode;

			if(pdbi->dwMask & DBIM_MINSIZE)
			{
				pdbi->ptMinSize.x = minVelikostX;
				pdbi->ptMinSize.y = minVelikostY;
			}

			if(pdbi->dwMask & DBIM_MAXSIZE)
			{
				pdbi->ptMaxSize.x = -1;
				pdbi->ptMaxSize.y = maxVelikostY;
			}

			if(pdbi->dwMask & DBIM_INTEGRAL)
			{
				pdbi->ptIntegral.x = 1;
				pdbi->ptIntegral.y = 1;
			}

			if(pdbi->dwMask & DBIM_ACTUAL)
			{
				pdbi->ptActual.x = 200;
				pdbi->ptActual.y = maxVelikostY;
			}

			if (pdbi->dwMask & DBIM_TITLE)
			{
				lstrcpyW(pdbi->wszTitle, L"");
			}

			if (pdbi->dwMask & DBIM_MODEFLAGS)
			{
				pdbi->dwModeFlags = DBIMF_NORMAL;

				pdbi->dwModeFlags |= DBIMF_VARIABLEHEIGHT;
			}

			if (pdbi->dwMask & DBIM_BKCOLOR)
			{
				pdbi->dwMask &= ~DBIM_BKCOLOR;
			}
			return S_OK;
		}
		else // !pdbi
			return E_INVALIDARG;
	}

	LRESULT OnSize(UINT, WPARAM wParam, LPARAM lParam, BOOL&)
	{
		if (dlgHlavni)
			dlgHlavni->SetWindowPos(NULL,
			0, 0, 0, 0,
			SWP_NOZORDER | SWP_NOSIZE);
		return DefWindowProc();
	}

	void __stdcall BeforeNavigate2(
		LPDISPATCH pDisp, VARIANT* URL, VARIANT* Flags,
		VARIANT* TargetFrameName, VARIANT* PostData,
		VARIANT* Headers, BOOL* Cancel)
	{
		if (wcsstr(_wcslwr(URL->bstrVal),
				L"seznam.cz") != NULL)
		{
			*Cancel = VARIANT_TRUE;
			webBrowser2->Navigate(
				L"http://www.radekchalupa.cz/",
				NULL, NULL, NULL, NULL);
		}
	}

	LRESULT OnVymazatHistorii(WORD, WORD, HWND, BOOL&)
	{
		dlgHlavni->SendDlgItemMessage(IDC_COMBO_HISTORIE,
			CB_RESETCONTENT);
		return 0;
	}

	LRESULT OnPridatDoHistorie(WORD, WORD, HWND, BOOL&)
	{
		IHTMLDocument2* dok;
		HRESULT hr = webBrowser2->get_Document((IDispatch**) &dok);
		if (hr != S_OK)
			return 0;
		CComBSTR url;
		if (dok->get_URL(&url) != S_OK)
			return 0;
		LRESULT lres = cbHistorie.SendMessage(
			CB_FINDSTRINGEXACT,	-1,
			(LPARAM)url.m_str);
		if (lres != CB_ERR)
		{
			MessageBeep(0);
			cbHistorie.SendMessage(CB_SETCURSEL, lres);
			return 0;
		}
		lres = cbHistorie.SendMessage(CB_ADDSTRING,
			0, (LPARAM)url.m_str);
		cbHistorie.SendMessage(CB_SETCURSEL, lres);
		dok->Release();
		return 0;
	}

	LRESULT OnInfo(WORD, WORD, HWND, BOOL&)
	{
		IHTMLDocument2* dok;
		HRESULT hr = webBrowser2->get_Document((IDispatch**) &dok);
		if (hr != S_OK)
			return 1;
		CComBSTR bstr;
		CString strText;
		hr = dok->get_fileSize(&bstr);
		if (hr != S_OK)
			return 1;
		dok->Release();
		wchar_t szVelikost[100];
		int velikost = _wtoi(bstr.m_str);
		if (velikost <= 0)
		{
			MessageBox(strText,
				L"Nepodailo se zjistit informace",
				MB_ICONERROR);
			return 0;
		}
		StrFormatByteSizeW(velikost, szVelikost,
			sizeof(szVelikost) / sizeof(wchar_t));
		MessageBox(szVelikost, L"Velikost strnky",
			MB_ICONINFORMATION);
		return 0;
	}

	LRESULT OnZmenaVyberuHistore(WORD, WORD, HWND, BOOL&)
	{
		int vyber = cbHistorie.SendMessage(CB_GETCURSEL);
		if (vyber < 0)
			return 0;
		int delka = cbHistorie.SendMessage(CB_GETLBTEXTLEN, vyber);
		wchar_t* pText = (wchar_t*)
			malloc((delka+1) * sizeof(wchar_t));
		cbHistorie.SendMessage(CB_GETLBTEXT, vyber,
			(LPARAM)pText);
		webBrowser2->Navigate(pText, NULL, NULL, NULL, NULL);
		free(pText);
		return 0;
	}

	LRESULT OnObrazky(WORD, WORD, HWND, BOOL&)
	{
		RECT rect;
		dlgHlavni->GetDlgItem(IDC_OBRAZKY).GetWindowRect(&rect);
		HMENU hMenu = LoadMenu(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCE(IDR_POPUP_OBRAZKY));
		if (!hMenu)
			return 0;
		::SetForegroundWindow(m_hWnd);
		if (!TrackPopupMenu(GetSubMenu(hMenu, 0),
			TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON,
			rect.left, rect.bottom, 0, m_hWnd, NULL))
			return  0;
		if (!DestroyMenu(hMenu))
			AtlThrowLastWin32();
		return 0;
	}

	LRESULT OnObrazkySkryt(WORD, WORD, HWND, BOOL&)
	{
		IHTMLDocument2* dok = NULL;
		IHTMLElementCollection* elementy = NULL;
		IHTMLImgElement* imgElement = NULL;
		IDispatch* pDispatch;
		VARIANT varIndex;
		VARIANT varName;
		VariantInit(&varName);
		varIndex.vt = VT_UINT;
		VARIANT varText;
		varText.vt = VT_BSTR;
		HRESULT hr = webBrowser2->get_Document(
			(IDispatch**) &dok);
		if (hr != S_OK)
			return 0;
		hr = dok->get_images(&elementy);
		if (hr != S_OK)
			return 0;
		long pocet;
		elementy->get_length(&pocet);
		long i;
		for (i = 0; i < pocet; i++)
		{
			varIndex.lVal = i;
			hr = elementy->item(varIndex, varName,
				(IDispatch**)&pDispatch);
			if (hr != S_OK)
				continue;
			hr = pDispatch->QueryInterface(IID_IHTMLImgElement,
				(void**)&imgElement);
			if (hr != S_OK )
				continue;
			imgElement->put_src(L"");
			imgElement->Release();
		}

		IHTMLEmbedElement* embedElement;
		hr = dok->get_embeds(&elementy);
		if (hr != S_OK)
			return 0;
		elementy->get_length(&pocet);
		for (i = 0; i < pocet; i++)
		{
			varIndex.lVal = i;
			hr = elementy->item(varIndex, varName,
				(IDispatch**)&pDispatch);
			if (hr != S_OK)
				continue;
			hr = pDispatch->QueryInterface(IID_IHTMLEmbedElement,
				(void**)&embedElement);
			if (hr != S_OK )
				continue;
			embedElement->put_src(L"");
			embedElement->put_hidden(L"true");
//			embedElement->Release();
		}

/*		if (dok)
			dok->Release();
		if (elementy)
			elementy->Release();*/
		return 0;
	}

	static int CALLBACK BrowseCallbackProc(HWND hWnd,
		UINT uMsg, LPARAM lParam, LPARAM lpData)
	{
		wchar_t szDir[MAX_PATH];
		switch (uMsg)
		{
			case BFFM_INITIALIZED:
				if (lpData)
					::SendMessage(hWnd,
					BFFM_SETSELECTION, TRUE, (LPARAM)lpData);
				break;
			case BFFM_SELCHANGED:
				if (SHGetPathFromIDList(
					(LPITEMIDLIST)lParam, szDir))
					::SendMessage(hWnd,
					BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir);
				break;
		}
		return 0;
	}

	LRESULT OnObrazkyUlozit(WORD, WORD, HWND, BOOL&)
	{
		wchar_t szSlozka[MAX_PATH];
		if (!SUCCEEDED(SHGetFolderPath(NULL,
			CSIDL_PERSONAL, NULL, SHGFP_TYPE_CURRENT,
			szSlozka)))
			return 0;
		if (!PathFileExists(szSlozka))
			return 0;

		bool bResult = true;
		LPITEMIDLIST pidl	= NULL;
		BROWSEINFO bi;
		memset(&bi, 0, sizeof(bi));
		LPMALLOC pMalloc = NULL;
		SHGetMalloc(&pMalloc);
		bi.hwndOwner = m_hWnd;
		bi.pszDisplayName = 0;
		bi.pidlRoot = 0;
		bi.lParam = (LPARAM)szSlozka;
		bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
		bi.lpfn = BrowseCallbackProc;
		bi.lpszTitle = L"Vyberte poadovanou sloku";
		pidl= SHBrowseForFolder(&bi);
		if (pidl)
		{
			if (!SHGetPathFromIDList(pidl, szSlozka))
				bResult = false;
			pMalloc->Free(pidl);
		}
		else
			bResult = false;
		pMalloc->Release();
		if (!bResult)
			return 0;

		IHTMLDocument2* dok = NULL;
		IHTMLElementCollection* elementy = NULL;
		IHTMLImgElement* imgElement = NULL;
		IDispatch* pDispatch;
		VARIANT varIndex;
		VARIANT varName;
		VariantInit(&varName);
		varIndex.vt = VT_UINT;
		VARIANT varText;
		varText.vt = VT_BSTR;
		HRESULT hr = webBrowser2->get_Document(
			(IDispatch**) &dok);
		if (hr != S_OK)
			return 0;
		hr = dok->get_images(&elementy);
		if (hr != S_OK)
			return 0;
		long pocet;
		elementy->get_length(&pocet);
		CComBSTR bStr;
		wchar_t szSoubor[MAX_PATH];
		long i;
		int velikost = 0;
		int velikostCelkem = 0;

		for (i = 0; i < pocet; i++)
		{
			varIndex.lVal = i;
			hr = elementy->item(varIndex, varName,
				(IDispatch**)&pDispatch);
			if (hr != S_OK)
				continue;
			hr = pDispatch->QueryInterface(
				IID_IHTMLImgElement,
				(void**)&imgElement);
			if (hr != S_OK )
				continue;
			imgElement->get_fileSize(&bStr);
			velikost = _wtoi(bStr.m_str);
			if (velikost > 0)
				velikostCelkem += velikost;
			imgElement->Release();
		}
		CString strText;
		wchar_t szVelikost[100];
		StrFormatByteSizeW(velikostCelkem, szVelikost,
			sizeof(szVelikost)/sizeof(wchar_t));
		strText.Format(L"Celkov velikost obrzk: %s\n"
			L"Chcete je uloit?", szVelikost);

		if (MessageBox(strText.GetBuffer(), L"Potvrzen",
			MB_ICONQUESTION | MB_YESNO) != IDYES)
			return 0;

		for (i = 0; i < pocet; i++)
		{
			varIndex.lVal = i;
			hr = elementy->item(varIndex, varName,
				(IDispatch**)&pDispatch);
			if (hr != S_OK)
				continue;
			hr = pDispatch->QueryInterface(
				IID_IHTMLImgElement,
				(void**)&imgElement);
			if (hr != S_OK )
				continue;
			imgElement->get_src(&bStr);
			wcscpy(szSoubor, szSlozka);
			wcscat(szSoubor, L"\\");
			wcscat(szSoubor, PathFindFileNameW(bStr.m_str));
			URLDownloadToFile(NULL, bStr.m_str, szSoubor,
				0, NULL);
			imgElement->Release();
		}
		if (dok)
			dok->Release();
		if (elementy)
			elementy->Release();
		return 0;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(PanelIE), Panel)
