/****************************************************
Vlastn plugin pro Internet Explorer
Soubor: Plugin.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include "PluginIE.h"


// Plugin
class ATL_NO_VTABLE Plugin : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Plugin, &CLSID_PluginIE>,
	public IObjectWithSiteImpl< Plugin >,
	public IDispEventImpl<0, Plugin,
		&__uuidof(DWebBrowserEvents2), &LIBID_SHDocVw, 1, 0>,
	public IDispatchImpl<IPluginIE,
		&IID_IPluginIE, &LIBID_PluginIELib, 1, 0>
{
public:
	IWebBrowser2* webBrowser;
	IInputObjectSite* inputObjectSite;

	typedef IDispEventImpl<0, Plugin,
		&__uuidof(DWebBrowserEvents2),
		&LIBID_SHDocVw, 1, 0> tDispEvent;

public:
	Plugin()
	{
		inputObjectSite = NULL;
		webBrowser = NULL;
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_PLUGINIE1)
	DECLARE_PROTECT_FINAL_CONSTRUCT()

	BEGIN_COM_MAP(Plugin)
		COM_INTERFACE_ENTRY(IPluginIE)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(IObjectWithSite)
	END_COM_MAP()

	BEGIN_SINK_MAP(Plugin) 
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			0x000000fa, BeforeNavigate2)
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			DISPID_DOCUMENTCOMPLETE, DocumentComplete)
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			DISPID_NAVIGATECOMPLETE2, NavigateComplete2)
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			DISPID_NEWWINDOW3, NewWindow3)
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			DISPID_DOWNLOADBEGIN, OnDownloadBegin)
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			DISPID_DOWNLOADCOMPLETE, OnDownLoadComplete)
		SINK_ENTRY_EX(0, (__uuidof(DWebBrowserEvents2)),
			DISPID_ONQUIT, OnQuit)
	END_SINK_MAP()


	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	STDMETHOD(SetSite)(IUnknown* pUnkSite)
	{
		if (inputObjectSite)
		{
			inputObjectSite->Release();
			inputObjectSite = NULL;
		}
		HRESULT hRes;
		if (pUnkSite)
		{

			if (!webBrowser)
			{
				webBrowser = (IWebBrowser2*) pUnkSite;
				tDispEvent::DispEventAdvise(webBrowser);
			}
			return S_OK;
		}
		else
		{
			if (webBrowser)
				tDispEvent::DispEventUnadvise(webBrowser);	
		}
		return S_OK;
	}

	void __stdcall BeforeNavigate2(
		LPDISPATCH pDisp, VARIANT* URL, VARIANT* Flags,
		VARIANT* TargetFrameName, VARIANT* PostData,
		VARIANT* Headers, BOOL* Cancel)
	{
		if (wcsstr(_wcslwr(URL->bstrVal),
				L"xyz.cz") != NULL)
		{
			*Cancel = VARIANT_TRUE;
			webBrowser->Navigate(
				L"http://www.radekchalupa.cz/",
				NULL, NULL, NULL, NULL);
		}
	}

	void __stdcall NewWindow3(
		LPDISPATCH* ppDisp, BOOL* Cancel,
		unsigned long dwFlags,
		BSTR bstrUrlContext, BSTR bstrUrl)
	{
	}

	void __stdcall OnDownloadBegin()
	{
	}

	void __stdcall OnDownLoadComplete()
	{
	}

	void __stdcall NavigateComplete2(
		IDispatch* pDisp, VARIANT* URL)
	{
	}

	void __stdcall DocumentComplete(
		IDispatch* pDisp, VARIANT* URL)
	{
	}

	void __stdcall OnQuit()
	{
	}

};

OBJECT_ENTRY_AUTO(__uuidof(PluginIE), Plugin)
