#pragma once

#include "resource.h"

class OknoHlavni : public CWindowImpl< OknoHlavni >
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),// ikona
				(HCURSOR)NULL,
				(HBRUSH)GetSysColorBrush(COLOR_WINDOW),
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				_T("MojeHlavniOkno"),
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)) // mal ikona
			},
			NULL,
			NULL, // wndproc
			IDC_ARROW, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}

public:
	HBRUSH hbPozadi;

public:
	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
		COMMAND_ID_HANDLER(ID_POZADI_BITMAPA, OnPozadiBitmapa)
		COMMAND_RANGE_HANDLER(ID_POZADI_WINDOW,
			ID_POZADI_PLOCHA, OnBarvaPozadi)
	END_MSG_MAP()

	OknoHlavni()
	{
		hbPozadi = NULL;
	}

	~OknoHlavni()
	{
		if (this->hbPozadi)
		{
			LOGBRUSH lb;
			GetObject(this->hbPozadi, sizeof(lb), &lb);
			if (!DeleteObject(this->hbPozadi))
				AtlThrowLastWin32();
			if (!DeleteObject((HGDIOBJ)lb.lbHatch))
				AtlThrowLastWin32();
		}
	}

	LRESULT OnClose(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		::SetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND,
			(LONG_PTR)GetSysColorBrush(COLOR_WINDOW));
		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	bool Vytvorit()
	{
		RECT rect = {0, 0, 600, 450};
		if (!Create(NULL, &rect, _T("Moje prvn aplikace v ATL"),
			WS_OVERLAPPEDWINDOW))
			return false;
		UpdateWindow();
		CenterWindow();
		ShowWindow(SW_SHOW);
		return true;
	}

	LRESULT OknoHlavni::OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OknoHlavni::OnPozadiBitmapa(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (!this->hbPozadi)
		{
			HBITMAP hBitmap = LoadBitmap(_AtlBaseModule.m_hInst,
				MAKEINTRESOURCE(IDB_POZADI));
			if (!hBitmap)
				AtlThrowLastWin32();
			this->hbPozadi = CreatePatternBrush(hBitmap);
		}
		::SetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND,
			(LONG_PTR)this->hbPozadi);
		RedrawWindow();
		return 0;
	}

	LRESULT OknoHlavni::OnBarvaPozadi(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		switch (wID)
		{
		case ID_POZADI_DIALOG:
			::SetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND,
				(LONG_PTR)GetSysColorBrush(COLOR_3DFACE));
			break;
		case ID_POZADI_PLOCHA:
			::SetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND,
				(LONG_PTR)GetSysColorBrush(COLOR_DESKTOP));
			break;
		case ID_POZADI_WINDOW:
			::SetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND,
				(LONG_PTR)GetSysColorBrush(COLOR_WINDOW));
			break;
		}
		RedrawWindow();
		return 0;
	}
};
