/****************************************************
Prohle obrzk vyuvajc ActiveX
Soubor: ProhlizecObrazku.cpp
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#include "stdafx.h"
#include "resource.h"
#include "ProhlizecObrazku.h"

class Aplikace : public CAtlExeModuleT< Aplikace >,
	public CWindowImpl< Aplikace >
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),
				(HCURSOR)NULL,
				(HBRUSH)NULL, 
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				L"ProhlizecObrazku",
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI))
			},
			NULL, // origname
			NULL, // wndproc
			IDC_ARROW, // cursor ID
			TRUE, // system cursor
			0, // atom
			L""
		};
		return wc;
	}
public:
	DWORD gdiplusToken;
	CAxWindow2 axWindow;
	IImageAx* imageAx;
public :
	DECLARE_LIBID(LIBID_ATLLib)

	Aplikace()
	{
		imageAx = NULL;
	}

	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
		COMMAND_ID_HANDLER(ID_SOUBOR_OTEVRIT, OnSouborOtevrit)
		COMMAND_ID_HANDLER(ID_SOUBOR_ZAVRIT, OnSouborZavrit)
		COMMAND_ID_HANDLER(ID_OPIS_OBRAZOVKY, OnOpisObrazovky)
		COMMAND_ID_HANDLER(ID_PREKLOPIT_SVISLE, OnPreklopitSvisle)
		COMMAND_ID_HANDLER(ID_PREKLOPIT_VODOROVNE,
			OnPreklopitVodorovne)
		COMMAND_ID_HANDLER(ID_OTOCIT_VLEVO, OnOtocitVlevo)
		COMMAND_ID_HANDLER(ID_OTOCIT_VPRAVO, OnOtocitVpravo)
		COMMAND_ID_HANDLER(ID_NEGATIV, OnNegativ)
		COMMAND_ID_HANDLER(ID_STUPNE_SEDE, OnStupneSede)
		COMMAND_ID_HANDLER(ID_ULOZIT, OnUlozit)
		COMMAND_ID_HANDLER(ID_ULOZIT_BMP, OnUlozitBmp)
		COMMAND_ID_HANDLER(ID_ULOZIT_GIF, OnUlozitGif)
		COMMAND_ID_HANDLER(ID_ULOZIT_JPG, OnUlozitJpg)
		COMMAND_ID_HANDLER(ID_ULOZIT_PNG, OnUlozitPng)
		COMMAND_ID_HANDLER(ID_ULOZIT_TIFF, OnUlozitTiff)
	END_MSG_MAP()

	LRESULT OnDestroy(UINT uMsg,
		WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnSize(UINT uMsg,
		WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if (axWindow.IsWindow())
			axWindow.SetWindowPos(NULL, 0, 0,
			LOWORD(lParam), HIWORD(lParam),
			SWP_NOZORDER);
		return DefWindowProc();
	}

	HRESULT Aplikace::PreMessageLoop(int nShowCmd)
	{
		CAtlExeModuleT<Aplikace>::PreMessageLoop(nShowCmd);
		Lock();
		INITCOMMONCONTROLSEX icc;
		icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC = ICC_WIN95_CLASSES |
			ICC_USEREX_CLASSES | ICC_DATE_CLASSES |
			ICC_LISTVIEW_CLASSES |	ICC_COOL_CLASSES |
			ICC_BAR_CLASSES | ICC_INTERNET_CLASSES |
			ICC_NATIVEFNTCTL_CLASS | ICC_TAB_CLASSES |
			ICC_ANIMATE_CLASS;
		if (!InitCommonControlsEx(&icc))
			return E_FAIL;
		GdiplusStartupInput gdiplusStartupInput;
		GdiplusStartup(&gdiplusToken,
			&gdiplusStartupInput, NULL);
		RECT rect = { 0, 0, GetSystemMetrics(SM_CXSCREEN) * 0.75,
			GetSystemMetrics(SM_CYSCREEN) * 0.75};
		if (!Create(NULL, &rect, L"Prohle obrzk",
			WS_OVERLAPPEDWINDOW))
			return E_FAIL;
		HRESULT hr;
		axWindow.Create(m_hWnd, &rect, NULL, WS_CHILD,
			0, 1);
		hr = axWindow.CreateControl(L"RadekChalupa.ImageAx");
		if (FAILED(hr))
			return E_FAIL;
		hr = axWindow.QueryControl(&imageAx);
		if (FAILED(hr))
			return E_FAIL;
		CenterWindow();
		axWindow.ShowWindow(SW_SHOW);
		ShowWindow(SW_SHOW);
		return S_OK;
	}

	HRESULT Aplikace::PostMessageLoop()
	{
		GdiplusShutdown(gdiplusToken);
		Unlock();
		return CAtlExeModuleT<Aplikace>::PostMessageLoop();
	}

	LRESULT OnKonec(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnSouborOtevrit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->VybratSoubor();
		return 0;
	}

	LRESULT OnSouborZavrit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->Zavrit();
		return 0;
	}

	LRESULT OnOpisObrazovky(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->NacistOpisObrazovky();
		return 0;
	}

	LRESULT OnPreklopitSvisle(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->PreklopitSvisle();
		return 0;
	}

	LRESULT OnPreklopitVodorovne(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->PreklopitVodorovne();
		return 0;
	}

	LRESULT OnOtocitVlevo(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->OtocitVlevo90();
		return 0;
	}

	LRESULT OnOtocitVpravo(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->OtocitVpravo90();
		return 0;
	}

	LRESULT OnNegativ(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->InvertovatBarvy();
		return 0;
	}

	LRESULT OnStupneSede(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->PrevodNaStupneSede();
		return 0;
	}

	LRESULT OnUlozit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->Ulozit();
		return 0;
	}

	LRESULT OnUlozitBmp(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->UlozitVybratSouborBmp();
		return 0;
	}

	LRESULT OnUlozitJpg(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->UlozitVybratSouborJpeg();
		return 0;
	}

	LRESULT OnUlozitGif(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->UlozitVybratSouborGif();
		return 0;
	}

	LRESULT OnUlozitTiff(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->UlozitVybratSouborTiff();
		return 0;
	}

	LRESULT OnUlozitPng(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (imageAx)
			imageAx->UlozitVybratSouborPng();
		return 0;
	}
};

Aplikace _AtlModule;

extern "C" int WINAPI wWinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}
