/****************************************************
Rozen kontextov nabdky Przkumnka
 o poloky pro registraci COM serveru
Soubor: ObrShellExt.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include "RozsireniShellu.h"


// DemoShellExt

class ATL_NO_VTABLE DemoShellExt : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<DemoShellExt, &CLSID_DemoShellExt>,
	public IShellExtInit,
	public IContextMenu,
	public IDispatchImpl<IDemoShellExt, &IID_IDemoShellExt,
		&LIBID_RozsireniShelluLib, 1, 0>
{
public:
	wchar_t soubor[MAX_PATH];
public:
	DemoShellExt()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DEMOSHELLEXT)
	DECLARE_PROTECT_FINAL_CONSTRUCT()


BEGIN_COM_MAP(DemoShellExt)
	COM_INTERFACE_ENTRY(IDemoShellExt)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IShellExtInit)
	COM_INTERFACE_ENTRY(IContextMenu)
END_COM_MAP()



	HRESULT FinalConstruct()
	{
		ATLTRACE2(L"DemoDhellExt FinalConstruct\n");
		return S_OK;
	}
	
	void FinalRelease() 
	{
		ATLTRACE2(L"DemoDhellExt FinalRelease\n");
	}

	STDMETHOD(Initialize)(LPCITEMIDLIST pidlFolder,
		LPDATAOBJECT lpdobj, HKEY hkeyProgID)
	{
		if (lpdobj == NULL)
			return E_INVALIDARG;
		STGMEDIUM medium;
		FORMATETC fe = {CF_HDROP, NULL,
			DVASPECT_CONTENT, -1, TYMED_HGLOBAL};
		HRESULT hr = lpdobj->GetData(&fe, &medium);
		if (FAILED(hr))
			return E_INVALIDARG;
		DragQueryFile(reinterpret_cast<HDROP>(medium.hGlobal),
			0, this->soubor, MAX_PATH);
		ReleaseStgMedium(&medium);
		return hr;
	}

	STDMETHOD(QueryContextMenu)(HMENU hmenu,
		UINT indexMenu,
		UINT idCmdFirst, UINT idCmdLast,
		UINT uFlags)
	{
		if (!(CMF_DEFAULTONLY & uFlags))
		{
			InsertMenu(hmenu, indexMenu++,
				MF_STRING | MF_BYPOSITION,
				idCmdFirst, L"&Registrovat server");
			InsertMenu(hmenu, indexMenu++,
				MF_STRING | MF_BYPOSITION,
				idCmdFirst + 1,
				L"&Odregistrovat server");
			InsertMenu(hmenu, indexMenu++,
				MF_SEPARATOR | MF_BYPOSITION,
				idCmdFirst + 1, NULL);
			return MAKE_HRESULT(SEVERITY_SUCCESS,
				FACILITY_NULL, 2);
		}
		return MAKE_HRESULT(SEVERITY_SUCCESS,
			FACILITY_NULL, USHORT(0));
	}

	STDMETHOD(GetCommandString)(UINT idCmd,
		UINT uFlags, UINT *pwReserved,
		LPSTR pszName, UINT cchMax)
	{
		if (uFlags & GCS_HELPTEXT)
		{
			switch(idCmd)
			{
			case 0:
				if (uFlags & GCS_VERBA)
					strncpy(pszName,
					"Zaregistruje COM server", cchMax);
				else
					lstrcpynW((LPWSTR)pszName,
					L"Zaregistruje COM server",
					cchMax);
				break;
			case 1:
				if (uFlags & GCS_VERBA)
					strncpy(pszName,
					"Odregistruje COM server", cchMax);
				else
					lstrcpynW((LPWSTR)pszName,
					L"Odregistruje COM server", cchMax);
				break;
			}
			return S_OK;
		}
		return E_FAIL;
	}

	STDMETHOD(InvokeCommand)(LPCMINVOKECOMMANDINFO pici)
	{
		wchar_t parametry[MAX_PATH+6];
		UINT idOffset = LOWORD(pici->lpVerb);
		switch (idOffset)
		{	
			case 0:
				lstrcpy(parametry, L"\"");
				lstrcat(parametry, this->soubor);
				lstrcat(parametry, L"\"");
				ShellExecute(pici->hwnd, NULL, L"regsvr32.exe",
					parametry, NULL, 0);
				break;
			case 1:
				lstrcpy(parametry, L"/u \"");
				lstrcat(parametry, this->soubor);
				lstrcat(parametry, L"\"");
				ShellExecute(pici->hwnd, NULL, L"regsvr32.exe",
					parametry, NULL, 0);
				break;
				
		}
		return S_OK;
	}

};

OBJECT_ENTRY_AUTO(__uuidof(DemoShellExt), DemoShellExt)
