/****************************************************
Ukzka sluby Windows - webov server
Soubor: Sluzba.cpp
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#include "stdafx.h"
#include "resource.h"
#include "Sluzba.h"

class Aplikace : 
	public CAtlServiceModuleT<
	Aplikace, IDS_SERVICENAME >
{
public :
	CString jmeno;
	CString souborLog;
	DWORD maxVelikostLogu;
	SOCKET socketServer;
	HANDLE hThreadServer;
public :
	DECLARE_LIBID(LIBID_SluzbaLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_SLUZBA,
	"{60F4AD8F-DF65-4879-99A5-EE877445A7FD}")

	static unsigned __stdcall ThreadProcServer(void* parametr)
	{
		Aplikace* aplikace = (Aplikace*)parametr;
		aplikace->socketServer =
			socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
		if (aplikace->socketServer == INVALID_SOCKET)
			return -1;
		sockaddr_in service;
		service.sin_family = AF_INET;
		service.sin_addr.s_addr = INADDR_ANY;
		service.sin_port = htons(5566);
		char szBuffer[1024] = "";
		int prijatychBytu = 0;
		if (bind(aplikace->socketServer,
			(SOCKADDR*)&service, sizeof(service) ) == SOCKET_ERROR)
			return -1;
		if (listen(aplikace->socketServer, 1) == SOCKET_ERROR)
			return -1;
		SOCKET AcceptSocket;
		SYSTEMTIME st;
		CStringA strText;
//		CStringA strIP;
		CStringA strJmenoPocitace;
		sockaddr_in saKlient;
		ZeroMemory(&saKlient, sizeof(saKlient));
		int delkaSA = sizeof(saKlient);
		while (true)
		{
			AcceptSocket = SOCKET_ERROR;
			while (AcceptSocket == SOCKET_ERROR)
			{
				AcceptSocket = 
					accept(aplikace->socketServer,
					(SOCKADDR*)&saKlient, &delkaSA);
			}
//			strIP = CString(inet_ntoa(saKlient.sin_addr));
			ZjistitJmenoPocitace(
				inet_ntoa(saKlient.sin_addr),
				strJmenoPocitace);
			prijatychBytu = recv(AcceptSocket, szBuffer, 1024, 0);
			szBuffer[prijatychBytu] = '\0';
			if (strnicmp(szBuffer, "get", 3) == 0)
			{
				GetLocalTime(&st);
				strText.Format("<h1>Demo server</h1>"
					"<p>Zdravm %s (%s)!</p>"
					"<p>as na serveru: %d:%.2d:%.2d</p>",
					strJmenoPocitace.GetBuffer(),
					inet_ntoa(saKlient.sin_addr),
					st.wHour, st.wMinute, st.wSecond);
				send(AcceptSocket, (const char*)(strText.GetBuffer()),
					strlen(strText.GetBuffer())+1, 0);
				closesocket(AcceptSocket);
				strText.Format("%s (%s)",
					strJmenoPocitace.GetBuffer(),
					inet_ntoa(saKlient.sin_addr));
				aplikace->ZapisDoLogu(
					CString(strText.GetBuffer()).GetBuffer());
#ifdef _DEBUG
				MessageBox(NULL, CString(strText.GetBuffer()),
					L"Odeslno",
					MB_ICONINFORMATION | MB_SERVICE_NOTIFICATION);
#endif
				continue;
			}
			closesocket(AcceptSocket);
		}
		return 0;
	}

	static bool ZjistitJmenoPocitace(const char* pszIP, CStringA& strJmeno)
	{
		unsigned int adresa;
		HOSTENT* HostEnt;
		adresa = inet_addr(pszIP);
		HostEnt = gethostbyaddr((char*)&adresa, sizeof(int), AF_INET);
		if (HostEnt)
		{
			strJmeno = CStringA(HostEnt->h_name);
			return true;
		}
		else
			return false;
	}

	Aplikace()
	{
		maxVelikostLogu = 1000000;
		hThreadServer = NULL;
		socketServer = INVALID_SOCKET;
	}

	HRESULT InitializeSecurity() throw()
	{
		return S_OK;
	}

	HRESULT PreMessageLoop(int nShowCmd)
	{
		CAtlServiceModuleT<Aplikace,IDS_SERVICENAME>::PreMessageLoop(nShowCmd);
		WSADATA wsaData;
		WSAStartup( MAKEWORD(2,2), &wsaData );
		jmeno.LoadString(IDS_SERVICENAME);
		wchar_t szCesta[MAX_PATH];
		if (GetModuleFileName(NULL, szCesta, MAX_PATH) == 0)
			return E_FAIL;
		if (!PathRemoveFileSpec(szCesta))
			return E_FAIL;
		this->souborLog.Format(L"%s\\server.log",
			szCesta);
		unsigned int ui;
		hThreadServer = (HANDLE)
			_beginthreadex(NULL, 0,
			ThreadProcServer,
			(void*)this, 0, &ui);
		if (!hThreadServer)
			return E_FAIL;
		ZapisDoLogu(L"Sputno");
		return S_OK;
	}

	void Aplikace::Handler(DWORD dwOpcode)
	{
		switch ( dwOpcode )
		{
		case SERVICE_CONTROL_CONTINUE:
			ZapisDoLogu(L"Pokraovn");
			break;
		case SERVICE_CONTROL_PAUSE:
			ZapisDoLogu(L"Perueno");
			break;
		case SERVICE_CONTROL_STOP:
			ZapisDoLogu(L"Zastaveno");
			if (hThreadServer)
			{
				TerminateThread(hThreadServer, 0);
				Sleep(500);
			}
			break;
		}
		CAtlServiceModuleT<Aplikace,
			IDS_SERVICENAME>::Handler(dwOpcode);
	}

	bool ZapisDoLogu(const wchar_t* text)
	{
		try
		{
			HANDLE handle = CreateFile(souborLog.GetBuffer(),
				GENERIC_READ | GENERIC_WRITE,
				0, NULL, OPEN_ALWAYS, 0, NULL);
			if (handle == INVALID_HANDLE_VALUE)
				AtlThrowLastWin32();
			

			DWORD velikostSouboru =
				GetFileSize(handle, NULL);
			if (velikostSouboru > maxVelikostLogu)
			{
				CloseHandle(handle);
				return true;
			}

			SetFilePointer(handle, 0, NULL, FILE_END);
			SYSTEMTIME st;
			GetLocalTime(&st);
			wchar_t cas[30];
			wsprintf(cas, L"%d.%d.%d %d:%.2d:%.2d - ",
				st.wDay, st.wMonth, st.wYear,
				st.wHour, st.wMinute, st.wSecond);

			DWORD dw;
			if (!WriteFile(handle, cas,
				wcslen(cas) * sizeof(wchar_t),
				&dw, NULL))
				AtlThrowLastWin32();
			if (!WriteFile(handle, text,
				wcslen(text) * sizeof(wchar_t),
				&dw, NULL) )
				AtlThrowLastWin32();
			if (!WriteFile(handle, L"\r\n",
				wcslen(L"\r\n") * sizeof(wchar_t),
				&dw, NULL) )
				AtlThrowLastWin32();
			if (!CloseHandle(handle))
				AtlThrowLastWin32();
			return true;
		}
		catch (...)
		{
			LogEvent(L"Nepodailo se zapsat do log");
			return false;
		}
	}

};

Aplikace _AtlModule;


extern "C" int WINAPI _tWinMain(HINSTANCE,
	HINSTANCE, LPTSTR, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}
