/**********************************************************
Projekt: StylyOkna
Soubor: OknoHlavni.h
Copyright: (C) 2005 Radek Chalupa - www.radekchalupa.cz
**********************************************************/

#pragma once

#include "resource.h"

class OknoHlavni : public CWindowImpl< OknoHlavni >
{
public:
	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_CONTEXTMENU, OnContextMenu)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(ID_PLNE, OnZmenaStylu)
		COMMAND_ID_HANDLER(ID_POPUP, OnZmenaStylu)
		COMMAND_ID_HANDLER(ID_UZKY_TITULEK, OnZmenaStylu)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
	END_MSG_MAP()

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnContextMenu(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		POINT point;
		point.x = LOWORD(lParam);
		point.y = HIWORD(lParam);
		if ((point.x == 0x0000FFFF) || (point.y == 0x0000FFFF))
		{
			point.x = 0;
			point.y = 0;
			ClientToScreen(&point); 
		}
		HMENU hMenu = LoadMenu(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCE(IDR_HLAVNI));
		::SetForegroundWindow(m_hWnd);
		if (!TrackPopupMenu(GetSubMenu(hMenu, 0),
			TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON,
			point.x, point.y, 0, m_hWnd, NULL))
			AtlThrowLastWin32();
		if (!DestroyMenu(hMenu))
			AtlThrowLastWin32();
		return 0;
	}

	bool Vytvorit()
	{
		RECT rect = {0, 0, 600, 450};
		if (!Create(NULL, &rect, _T("Styly okna"),
			WS_OVERLAPPEDWINDOW))
			return false;
		CenterWindow();
		ShowWindow(SW_SHOW);
		return true;
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnZmenaStylu(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		ShowWindow(SW_HIDE);
		DWORD styl;
		DWORD exStyl;
		switch (wID)
		{
		case ID_PLNE:
			styl = WS_OVERLAPPEDWINDOW;
			exStyl = 0;
			break;
		case ID_POPUP:
			styl = WS_POPUP | WS_BORDER;
			exStyl = WS_EX_TOPMOST;
			break;
		case ID_UZKY_TITULEK:
			styl = WS_OVERLAPPEDWINDOW | WS_SYSMENU;
			exStyl = WS_EX_TOOLWINDOW;
			break;
		default:
			styl = WS_OVERLAPPEDWINDOW;
			exStyl = 0;
			break;
		}
		SetWindowLongPtr(GWL_STYLE, styl);
		SetWindowLongPtr(GWL_EXSTYLE, exStyl);
		SetWindowPos(NULL, 0, 0, 0, 0,
			SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_FRAMECHANGED);
		ShowWindow(SW_SHOW);
		return 0;
	}
};
