/****************************************************
TextEdit ActveX
Soubor: TextEditAx.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once
#include "resource.h"
#include <atlctl.h>
#include "TextEditObj.h"
#include "_ITextEditAxEvents_CP.h"

// TextEdit
class ATL_NO_VTABLE TextEdit : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<TextEdit, ITextEditAx>,
	public IPersistStreamInitImpl<TextEdit>,
	public IOleControlImpl<TextEdit>,
	public IOleObjectImpl<TextEdit>,
	public IOleInPlaceActiveObjectImpl<TextEdit>,
	public IViewObjectExImpl<TextEdit>,
	public IOleInPlaceObjectWindowlessImpl<TextEdit>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<TextEdit>,
	public CProxy_ITextEditAxEvents<TextEdit>, 
	public IPersistStorageImpl<TextEdit>,
	public ISpecifyPropertyPagesImpl<TextEdit>,
	public IQuickActivateImpl<TextEdit>,
	public IDataObjectImpl<TextEdit>,
	public IProvideClassInfo2Impl<&CLSID_TextEditAx,
		&__uuidof(_ITextEditAxEvents),
		&LIBID_TextEditObjLib>,
	public CComCoClass<TextEdit, &CLSID_TextEditAx>,
	public CComControl<TextEdit>
{
public:
	static const int obrOtevrit = 0;
	static const int obrUlozit = 1;
	static const int obrVybratBarvu = 2;
	static const int obrVybratPismo = 3;
	static const int obrNovySoubor = 4;
	static const int obrUnicode = 5;
public:
	CContainedWindow m_ctlEdit;
	HBRUSH hbPozadi;
	CComBSTR bstrSoubor;
	bool unicodeText;
	HIMAGELIST himagelist;
	ToolBar* toolBar;
	HFONT hFont;

#pragma warning(push)
#pragma warning(disable: 4355)

	TextEdit()
		: m_ctlEdit(_T("Edit"), this, 1)
	{
		m_bWindowOnly = TRUE;
		hbPozadi = NULL;
		m_clrBackColor = GetSysColor(COLOR_WINDOW);
		m_clrForeColor = GetSysColor(COLOR_WINDOWTEXT);
		bstrSoubor = L"";
		unicodeText = false;
		toolBar = NULL;
		hFont = NULL;
	}

#pragma warning(pop)

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_TEXTEDITAX)

BEGIN_COM_MAP(TextEdit)
	COM_INTERFACE_ENTRY(ITextEditAx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(TextEdit)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("BackColor", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("ForeColor", DISPID_FORECOLOR, CLSID_StockColorPage)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(TextEdit)
	CONNECTION_POINT_ENTRY(__uuidof(_ITextEditAxEvents))
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(TextEdit)
	MESSAGE_HANDLER(WM_CTLCOLOREDIT, OnCtlColorEdit)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_NOTIFY, OnNotify)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_SIZE, OnSize)
	COMMAND_ID_HANDLER(ID_OTEVRIT_SOUBOR,
		OnOtevritSoubor)
	COMMAND_ID_HANDLER(ID_NOVY_SOUBOR, OnNovySoubor)
	COMMAND_ID_HANDLER(ID_VYBRAT_PISMO, OnVybratPismo)
	COMMAND_ID_HANDLER(ID_VYBRAT_POZADI, OnVybratPozadi)
	COMMAND_ID_HANDLER(ID_ULOZIT_JAKO, OnUlozitJako)
	COMMAND_ID_HANDLER(ID_UNICODE, OnUnicode)
	COMMAND_ID_HANDLER(ID_ULOZIT_SOUBOR,
		OnUlozitSoubor)
	COMMAND_ID_HANDLER(ID_ULOZIT_SOUBOR,
		OnUlozitSoubor)
	COMMAND_HANDLER(1, EN_CHANGE, OnEnChange)
	CHAIN_MSG_MAP(CComControl<TextEdit>)
ALT_MSG_MAP(1)
	MESSAGE_HANDLER(WM_KEYDOWN, OnEditKeyDown)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnEditLButtonDown)
END_MSG_MAP()

	BOOL PreTranslateAccelerator(LPMSG pMsg,
		HRESULT& hRet)
	{
		if(pMsg->message == WM_KEYDOWN)
		{
			switch(pMsg->wParam)
			{
			case VK_LEFT:
			case VK_RIGHT:
			case VK_UP:
			case VK_DOWN:
			case VK_HOME:
			case VK_END:
			case VK_NEXT:
			case VK_PRIOR:
				hRet = S_FALSE;
				return TRUE;
			}
		}
		return FALSE;
	}

	LRESULT OnEditKeyDown(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lr = m_ctlEdit.DefWindowProc();
		FireZmenaPozice();
		return lr;
	}

	LRESULT OnEditLButtonDown(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lr = m_ctlEdit.DefWindowProc();
		FireZmenaPozice();
		return lr;
	}

	LRESULT OnCtlColorEdit(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		COLORREF crBarva;
		OleTranslateColor(m_clrBackColor,
			NULL, &crBarva);
		if (this->hbPozadi)
		{
			SetBkColor((HDC)wParam, crBarva);
			OleTranslateColor(m_clrForeColor,
				NULL, &crBarva);
			SetTextColor((HDC)wParam, crBarva);
			return (LRESULT)this->hbPozadi;
		}
		else
			return (LRESULT)GetSysColorBrush(COLOR_WINDOW);
	}

	void FireZmenaPozice()
	{
		int radek = m_ctlEdit.SendMessage(
			EM_LINEFROMCHAR, -1, 0);
		DWORD znak;
		m_ctlEdit.SendMessage(EM_GETSEL, (WPARAM)&znak);
		int index = m_ctlEdit.SendMessage(
			EM_LINEINDEX, -1, 0);
		Fire_ZmenaPozice(radek + 1,
			znak - index + 1);
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lRes = CComControl<TextEdit>::
			OnSetFocus(uMsg, wParam,
			lParam, bHandled);
		if (m_bInPlaceActive)
		{
			if(!IsChild(::GetFocus()))
				m_ctlEdit.SetFocus();
		}
		return lRes;
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		RECT rectTB = {0, 0, 0, 0};
		if (toolBar)
		{
			toolBar->SendMessage(uMsg, wParam, lParam);
			toolBar->GetWindowRect(&rectTB);
		}
		if (m_ctlEdit.IsWindow())
			m_ctlEdit.SetWindowPos(NULL,
			0,
			rectTB.bottom - rectTB.top,
			LOWORD(lParam),
			HIWORD(lParam) - (rectTB.bottom - rectTB.top),
			SWP_NOZORDER);

		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (toolBar)
		{
			delete toolBar;
			toolBar = NULL;
		}
		return DefWindowProc();
	}

	LRESULT OnCreate(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		RECT rc;
		GetWindowRect(&rc);
		rc.right -= rc.left;
		rc.bottom -= rc.top;
		rc.top = rc.left = 0;
		m_ctlEdit.Create(m_hWnd, rc, L"",
			WS_CHILD | WS_VSCROLL | WS_HSCROLL |
			WS_VISIBLE | ES_WANTRETURN |
			ES_MULTILINE | ES_AUTOHSCROLL |
			ES_AUTOHSCROLL | WS_TABSTOP,
			WS_EX_CLIENTEDGE,
			1);
		m_ctlEdit.SetFont((HFONT)
			GetStockObject(DEFAULT_GUI_FONT), TRUE);
		VytvoritToolBar();
		return 0;
	}

	LRESULT OnOtevritSoubor(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		VybratSoubor();
		return 0;
	}

	LRESULT OnUnicode(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (!toolBar)
			return 0;
		if (toolBar->GetZaskrtnuti(ID_UNICODE))
		{
			this->unicodeText = false;
			toolBar->Zaskrtnout(ID_UNICODE, false);
		}
		else
		{
			this->unicodeText = true;
			toolBar->Zaskrtnout(ID_UNICODE, true);
		}
		return 0;
	}

	LRESULT OnUlozitSoubor(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		Ulozit();
		if (toolBar)
			toolBar->PovolitTlacitko(ID_ULOZIT_SOUBOR,
				false);
		return 0;
	}

	LRESULT OnUlozitJako(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (!VybratSouborUlozit())
			return 0;
		Ulozit();
		return 0;
	}

	LRESULT OnVybratPismo(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		VybratPismo();
		return 0;
	}

	LRESULT OnVybratPozadi(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		VybratPozadi();
		return 0;
	}

	LRESULT OnNovySoubor(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		NovySoubor();
		return 0;
	}

	LRESULT OnNotify(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		static NMTTDISPINFOW* pTTDISPINFO;
		CString strText;
		if (((NMHDR*)lParam)->code == TTN_GETDISPINFO)
		{
			pTTDISPINFO = (NMTTDISPINFOW*)lParam;
			pTTDISPINFO->hinst = _AtlBaseModule.m_hInst;
			if (strText.LoadString(pTTDISPINFO->hdr.idFrom))
			{
				wcscpy(pTTDISPINFO->lpszText,
					strText.GetBuffer());
			}
		}
		bHandled = FALSE;
		return DefWindowProc();
	}

	LRESULT OnEnChange(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (toolBar)
			toolBar->PovolitTlacitko(ID_ULOZIT_SOUBOR,
				true);
		Fire_ZmenaTextu();
		return 0;
	}

	STDMETHOD(SetObjectRects)(LPCRECT prcPos,
		LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<TextEdit>::
			SetObjectRects(prcPos, prcClip);
		int cx, cy;
		RECT rectTB = {0, 0, 0, 0};
		if (toolBar)
		{
			toolBar->GetWindowRect(&rectTB);
		}
		cx = prcPos->right - prcPos->left;
		cy = prcPos->bottom - prcPos->top - 0;
		::SetWindowPos(m_ctlEdit.m_hWnd, NULL,
			0,
			rectTB.bottom - rectTB.top,
			cx,
			cy - (rectTB.bottom-rectTB.top),
			SWP_NOZORDER | SWP_NOACTIVATE);
		return S_OK;
	}

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_ITextEditAx,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// ITextEditAx
	OLE_COLOR m_clrBackColor;
	void OnBackColorChanged()
	{
		COLORREF crBarva;
		OleTranslateColor(m_clrBackColor,
			NULL, &crBarva);
		if (hbPozadi)
			if (!DeleteObject(hbPozadi))
				AtlThrowLastWin32();
		hbPozadi = CreateSolidBrush(crBarva);
		if (!hbPozadi)
			AtlThrowLastWin32();
		if (m_ctlEdit.IsWindow())
			m_ctlEdit.RedrawWindow();
		OleTranslateColor(m_clrBackColor,
			NULL, &crBarva);
		Fire_ZmenaPozadi(crBarva);
	}

	OLE_COLOR m_clrForeColor;
	void OnForeColorChanged()
	{
		if (m_ctlEdit.IsWindow())
			m_ctlEdit.RedrawWindow();
		COLORREF crBarva;
		OleTranslateColor(m_clrForeColor,
			NULL, &crBarva);
		Fire_ZmenaBarvyTextu(crBarva);
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		HBITMAP hBitmap = NULL;
		himagelist = ImageList_Create(16, 16,
			ILC_COLOR32 | ILC_MASK, 1, 1);
		if (!himagelist)
			return E_HANDLE;
		hBitmap = LoadBitmap(_AtlBaseModule.m_hInst,
			MAKEINTRESOURCE(IDB_IMAGELIST));
		if (!hBitmap)
			return E_HANDLE;
		if (ImageList_AddMasked(himagelist,
			hBitmap, 0x0000FF00) == -1)
			return E_HANDLE;
		if (!DeleteObject(hBitmap))
			throw 0;

		COLORREF crBarva;
		OleTranslateColor(m_clrBackColor,
			NULL, &crBarva);
		hbPozadi = CreateSolidBrush(crBarva);
		if (!hbPozadi)
			AtlThrowLastWin32();
		return S_OK;
	}
	
	void FinalRelease() 
	{
		if (hbPozadi)
			if (!DeleteObject(hbPozadi))
				AtlThrowLastWin32();
		hbPozadi = NULL;
		if (hFont)
			if (!DeleteObject(hFont))
				AtlThrowLastWin32();
		hFont = NULL;
		if (himagelist)
		{
			if (!ImageList_Destroy(himagelist))
				AtlThrowLastWin32();
			himagelist = NULL;
		}
	}

	STDMETHOD(VybratSoubor)()
	{
		OPENFILENAME ofn;
		wchar_t soubor[MAX_PATH];
		wcsncpy(soubor, bstrSoubor.m_str, MAX_PATH);
		memset(&ofn, 0, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.lpstrFile = soubor;
		ofn.nMaxFile = MAX_PATH;
		ofn.hwndOwner = m_hWnd;
		ofn.lpstrFilter = L"Textov soubory (*.txt)\0"
			L"*.txt\0"
			L"Vechny soubory\0"
			L"*.*\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrDefExt = L"txt";
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
		if (!GetOpenFileName(&ofn))
			return S_FALSE;
		SetSoubor(soubor);
		return S_OK;
	}


	bool NacistSoubor()
	{
		if (!m_ctlEdit.IsWindow())
			return false;
		if (bstrSoubor.Length() < 1)
			return false;
		HANDLE hSoubor = INVALID_HANDLE_VALUE;
		BYTE* buffer = NULL;
		try
		{
			hSoubor =  CreateFile(bstrSoubor.m_str,
				GENERIC_READ, 0, NULL,
				OPEN_EXISTING, 0, NULL);
			if (hSoubor == INVALID_HANDLE_VALUE)
				throw 0;
			DWORD velikost = GetFileSize(hSoubor, NULL);
			if (velikost == INVALID_FILE_SIZE)
				throw 0;
			buffer = (BYTE*)HeapAlloc(GetProcessHeap(),
				HEAP_ZERO_MEMORY,
				velikost + sizeof(wchar_t));
			memset(buffer+velikost-sizeof(wchar_t),
				0, sizeof(wchar_t));
			DWORD nacteno;
			if (!ReadFile(hSoubor, buffer,
				velikost, &nacteno, NULL))
				throw 0;
			if (!CloseHandle(hSoubor))
				throw 0;
			hSoubor = INVALID_HANDLE_VALUE;
			if (*buffer == 0xFF && *(buffer+1) == 0xFE)
			{
				unicodeText = true;	
				::SetWindowTextW(m_ctlEdit.m_hWnd,
					(wchar_t*)(buffer+2));
			}
			else
			{
				unicodeText = false;	
				::SetWindowTextA(m_ctlEdit.m_hWnd,
					(char*)buffer);
			}
			HeapFree(GetProcessHeap(), 0, buffer);
			if (toolBar)
				toolBar->Zaskrtnout(ID_UNICODE,
				unicodeText);
			return true;
		}
		catch (...)
		{
			if (hSoubor != INVALID_HANDLE_VALUE)
				if (!CloseHandle(hSoubor))
					AtlThrowLastWin32();
			if (buffer)
				HeapFree(GetProcessHeap(),
					0, buffer);
			return false;
		}
	}

	bool UlozitSoubor()
	{
		if (!m_ctlEdit.IsWindow())
			return false;
		if (bstrSoubor.Length() < 1)
			return false;
		HANDLE hSoubor = INVALID_HANDLE_VALUE;
		CStringA textA;
		CStringW textW;
		try
		{
			hSoubor =  CreateFile(bstrSoubor.m_str,
				GENERIC_WRITE, 0, NULL,
				CREATE_ALWAYS, 0, NULL);
			if (hSoubor == INVALID_HANDLE_VALUE)
				throw 0;
			CString text;
			m_ctlEdit.GetWindowText(text);
			DWORD zapsano;
			if (unicodeText)
			{
				BYTE unSign[2] = {0xFF,0xFE};
				if (!WriteFile(hSoubor,
					unSign,
					sizeof(unSign),
					&zapsano, NULL))
					throw 0;
				if (!WriteFile(hSoubor,
					text.GetBuffer(),
					text.GetLength()*sizeof(wchar_t),
					&zapsano, NULL))
					throw 0;
			}
			else
			{
				textA = CStringA(text.GetBuffer());
				if (!WriteFile(hSoubor,
					CStringA(text.GetBuffer()).GetBuffer(),
					text.GetLength(),
					&zapsano, NULL))
					throw 0;
			}
			if (!CloseHandle(hSoubor))
				throw 0;
			hSoubor = INVALID_HANDLE_VALUE;
			return true;
		}
		catch (...)
		{
			if (hSoubor != INVALID_HANDLE_VALUE)
				if (!CloseHandle(hSoubor))
					AtlThrowLastWin32();
			return false;
		}
	}

	bool VybratSouborUlozit()
	{
		OPENFILENAME ofn;
		wchar_t soubor[MAX_PATH];
		wcsncpy(soubor, bstrSoubor.m_str, MAX_PATH);
		memset(&ofn, 0, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.lpstrFile = soubor;
		ofn.nMaxFile = MAX_PATH;
		ofn.hwndOwner = m_hWnd;
		ofn.lpstrFilter = L"Textov soubory (*.txt)\0"
			L"*.txt\0"
			L"Vechny soubory\0"
			L"*.*\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrDefExt = L"txt";
		ofn.Flags = OFN_PATHMUSTEXIST;
		if (!GetSaveFileName(&ofn))
			return false;
		bstrSoubor = CComBSTR(soubor);
		return true;
	}

	STDMETHOD(Ulozit)(void)
	{
		if (bstrSoubor.Length() < 1)
			if (!VybratSouborUlozit())
				return S_FALSE;
		UlozitSoubor();
		return S_OK;
	}

	void NovySoubor()
	{
		if (m_ctlEdit)
			m_ctlEdit.SetWindowText(L"");
		SetSoubor(L"");
	}

	STDMETHOD(VybratPozadi)()
	{
		if (!m_ctlEdit.IsWindow())
			return S_FALSE;
		COLORREF crBarva;
		OleTranslateColor(m_clrBackColor,
			NULL, &crBarva);
		CHOOSECOLOR cc;
		static COLORREF crVlastni[16];
		memset(&cc, 0, sizeof(cc));
		cc.lStructSize = sizeof(cc);
		cc.hwndOwner = m_hWnd;
		cc.lpCustColors = (DWORD*)crVlastni;
		cc.rgbResult = crBarva;
		cc.Flags = CC_FULLOPEN | CC_RGBINIT;
		if (!ChooseColor(&cc))
			return S_FALSE;
		put_BackColor((OLE_COLOR)cc.rgbResult);
		m_ctlEdit.RedrawWindow();
		return S_OK;
	}

	STDMETHOD(VybratPismo)()
	{
		if (!m_ctlEdit.IsWindow())
			return S_FALSE;
		CHOOSEFONT cf;
		LOGFONT lf;
		COLORREF crBarva;
		OleTranslateColor(m_clrForeColor,
			NULL, &crBarva);
		HFONT hf = (HFONT)
			m_ctlEdit.SendMessage(WM_GETFONT);
		GetObject(hf, sizeof(lf), &lf);
		memset(&cf, 0, sizeof(cf));
		cf.lStructSize = sizeof(cf);
		cf.hwndOwner = m_hWnd;
		cf.lpLogFont = &lf;
		cf.rgbColors = crBarva;
		cf.Flags = CF_SCREENFONTS |
			CF_EFFECTS | CF_INITTOLOGFONTSTRUCT;
		if (!ChooseFont(&cf))
			return S_FALSE;
		put_ForeColor((OLE_COLOR)cf.rgbColors);
		if (this->hFont)
			if (!DeleteObject(this->hFont))
				AtlThrowLastWin32();
		this->hFont = CreateFontIndirect(cf.lpLogFont);
		if (!this->hFont)
			AtlThrowLastWin32();
		m_ctlEdit.SetFont(this->hFont, TRUE);
		m_ctlEdit.RedrawWindow();
		Fire_ZmenaBarvyTextu(cf.rgbColors);
		return S_OK;
	}

	STDMETHOD(SetSoubor)(BSTR soubor)
	{
		bstrSoubor = CComBSTR(soubor);
		NacistSoubor();
		return S_OK;
	}

	STDMETHOD(GetSoubor)(BSTR* pSoubor)
	{
		bstrSoubor.CopyTo(pSoubor);
		return S_OK;
	}

	STDMETHOD(SetText)(BSTR text)
	{
		if (!m_ctlEdit.IsWindow())
			return S_FALSE;
		m_ctlEdit.SetWindowText(text);
		Fire_ZmenaTextu();
		return S_OK;
	}

	STDMETHOD(GetText)(BSTR* pText)
	{
		if (!m_ctlEdit.IsWindow())
			return S_FALSE;
		CComBSTR bstrText;
		m_ctlEdit.GetWindowText(&bstrText);
		bstrText.CopyTo(pText);
		return S_OK;
	}

	STDMETHOD(ZobrazitToolBar)(VARIANT_BOOL zobrazit)
	{
		if (!IsWindow())
			return E_HANDLE;
		if (toolBar)
		{
			delete toolBar;
			toolBar = NULL;
		}
		else
			VytvoritToolBar();
		RECT rect;
		GetClientRect(&rect);
		PostMessage(WM_SIZE, 0,
			MAKELPARAM(rect.right, rect.bottom));
		return S_OK;
	}

	void VytvoritToolBar()
	{
		if (toolBar)
			return;
		toolBar = new ToolBar();
		toolBar->Vytvorit(m_hWnd,
			himagelist);
		toolBar->PridatTlacitko(ID_NOVY_SOUBOR,
			obrNovySoubor);
		toolBar->PridatTlacitko(ID_OTEVRIT_SOUBOR,
			obrOtevrit);
		toolBar->PridatTlacitko(ID_ULOZIT_SOUBOR,
			obrUlozit);
		toolBar->PridatTlacitko(ID_ULOZIT_JAKO,
			obrUlozit);
		toolBar->PridatOddelovac();
		toolBar->PridatTlacitko(ID_VYBRAT_POZADI,
			obrVybratBarvu);
		toolBar->PridatTlacitko(ID_VYBRAT_PISMO,
			obrVybratPismo);
		toolBar->PridatOddelovac();
		toolBar->PridatTlacitko(ID_UNICODE,
			obrUnicode);
		toolBar->PovolitTlacitko(ID_ULOZIT_SOUBOR,
			false);
	}

	STDMETHOD(ToolBarExistuje)(VARIANT_BOOL* pExistuje)
	{
		*pExistuje = toolBar != NULL;
		return S_OK;
	}

	STDMETHOD(UlozitJako)(BSTR soubor)
	{
		if (soubor)
		{
			bstrSoubor = CComBSTR(soubor);
			Ulozit();
		}
		else
		{
			if (!VybratSouborUlozit())
				return S_FALSE;
			Ulozit();
		}
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(TextEditAx), TextEdit)
