// UdalostiAx.h : Declaration of the UdalostiAx
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "UdalostiObj.h"
#include "_IUdalostiAxEvents_CP.h"

// UdalostiAx
class ATL_NO_VTABLE UdalostiAx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IUdalostiAx, &IID_IUdalostiAx, &LIBID_UdalostiObjLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<UdalostiAx>,
	public IOleControlImpl<UdalostiAx>,
	public IOleObjectImpl<UdalostiAx>,
	public IOleInPlaceActiveObjectImpl<UdalostiAx>,
	public IViewObjectExImpl<UdalostiAx>,
	public IOleInPlaceObjectWindowlessImpl<UdalostiAx>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<UdalostiAx>,
	public CProxy_IUdalostiAxEvents<UdalostiAx>, 
	public IPersistStorageImpl<UdalostiAx>,
	public ISpecifyPropertyPagesImpl<UdalostiAx>,
	public IQuickActivateImpl<UdalostiAx>,
	public IDataObjectImpl<UdalostiAx>,
	public IProvideClassInfo2Impl<&CLSID_UdalostiAx, &__uuidof(_IUdalostiAxEvents), &LIBID_UdalostiObjLib>,
	public CComCoClass<UdalostiAx, &CLSID_UdalostiAx>,
	public CComCompositeControl<UdalostiAx>
{
public:
	UdalostiAx()
	{
		m_bWindowOnly = TRUE;
		CalcExtent(m_sizeExtent);
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_UDALOSTIAX)

BEGIN_COM_MAP(UdalostiAx)
	COM_INTERFACE_ENTRY(IUdalostiAx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(UdalostiAx)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(UdalostiAx)
	CONNECTION_POINT_ENTRY(__uuidof(_IUdalostiAxEvents))
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(UdalostiAx)
	COMMAND_HANDLER(IDC_CISLO, BN_CLICKED, OnCislo)
	COMMAND_HANDLER(IDC_TEXT, BN_CLICKED, OnText)
	COMMAND_HANDLER(IDC_TEXT_OUT, BN_CLICKED, OnTextOut)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDC_CISLO_OUT, BN_CLICKED, OnCisloOut)
	CHAIN_MSG_MAP(CComCompositeControl<UdalostiAx>)
END_MSG_MAP()

BEGIN_SINK_MAP(UdalostiAx)
END_SINK_MAP()

	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid)
	{
		if (dispid == DISPID_AMBIENT_BACKCOLOR)
		{
			SetBackgroundColorFromAmbient();
			FireViewChange();
		}
		return IOleControlImpl<UdalostiAx>::OnAmbientPropertyChange(dispid);
	}
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IUdalostiAx,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IUdalostiAx

	enum { IDD = IDD_UDALOSTIAX };

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
//		if (timer)
//			KillTimer(1);
	}

	LRESULT OnCislo(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		int cislo = GetDlgItemInt(IDC_EDIT_CISLO);
		Fire_UdalostCislo((ULONG)cislo);
		return 0;
	}

	LRESULT OnText(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CComBSTR text;
		GetDlgItemText(IDC_EDIT_TEXT, text.m_str);
		Fire_UdalostText(text.m_str);
		return 0;
	}

LRESULT OnTextOut(WORD wNotifyCode,
	WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	CComBSTR text;
	GetDlgItemText(IDC_EDIT_TEXT, text.m_str);
	Fire_UdalostTextOut(&text.m_str);
	SetDlgItemText(IDC_EDIT_TEXT, text.m_str);
	return 0;
}

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		SetDlgItemInt(IDC_EDIT_CISLO, 28);
		SetDlgItemInt(IDC_EDIT_TIMER, 0);
		SetDlgItemText(IDC_EDIT_TEXT, L"Mj text");
		return 1;
	}

	LRESULT OnCisloOut(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		int cislo = GetDlgItemInt(IDC_EDIT_CISLO);
		Fire_UdalostCisloOut((ULONG*)&cislo);
		SetDlgItemInt(IDC_EDIT_CISLO, cislo);
		BOOL vb = FALSE;
		Fire_Konec(cislo, (VARIANT_BOOL*) &vb);
		if (vb)
			MessageBox(L"Poadavek na konec");
		return 0;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(UdalostiAx), UdalostiAx)
