#pragma once

template<class T>
class CProxy_IUdalostiAxEvents :
	public IConnectionPointImpl<T, &__uuidof(_IUdalostiAxEvents)>
{
public:
	HRESULT Fire_UdalostCislo( ULONG  cislo)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();
		for (int iConnection = 0;
			iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection = m_vec.GetAt(iConnection);
			pThis->Unlock();
			IDispatch * pConnection = 
				static_cast<IDispatch *>(punkConnection.p);
			if (pConnection)
			{
				CComVariant avarParams[1];
				avarParams[0] = cislo;
				avarParams[0].vt = VT_UI4;
				DISPPARAMS params = { avarParams, NULL, 1, 0 };
				hr = pConnection->Invoke(1, IID_NULL,
					LOCALE_USER_DEFAULT,
					DISPATCH_METHOD, &params, NULL, NULL, NULL);
			}
		}
		return hr;
	}

	HRESULT Fire_UdalostText( BSTR  text)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();
		for (int iConnection = 0;
			iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection
				= m_vec.GetAt(iConnection);
			pThis->Unlock();
			IDispatch* pConnection =
				static_cast<IDispatch *>(punkConnection.p);
			if (pConnection)
			{
				CComVariant avarParams[1];
				avarParams[0] = text;
				avarParams[0].vt = VT_BSTR;
				DISPPARAMS params = { avarParams, NULL, 1, 0 };
				hr = pConnection->Invoke(2,
					IID_NULL, LOCALE_USER_DEFAULT,
					DISPATCH_METHOD,
					&params, NULL, NULL, NULL);
			}
		}
		return hr;
	}

	HRESULT Fire_UdalostCisloOut(ULONG *  pCislo)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();
		for (int iConnection = 0;
			iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection =
				m_vec.GetAt(iConnection);
			pThis->Unlock();
			IDispatch* pConnection =
				static_cast<IDispatch *>(punkConnection.p);
			if (pConnection)
			{
				CComVariant avarParams[1];
				avarParams[0].pulVal = pCislo;
				avarParams[0].vt = VT_UI4 | VT_BYREF;
				DISPPARAMS params = { avarParams, NULL, 1, 0 };
				hr = pConnection->Invoke(3,
					IID_NULL, LOCALE_USER_DEFAULT,
					DISPATCH_METHOD,
					&params, NULL, NULL, NULL);
			}
		}
		return hr;
	}

	HRESULT Fire_UdalostTextOut(BSTR *  pText)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();

		for (int iConnection = 0;
			iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection =
				m_vec.GetAt(iConnection);
			pThis->Unlock();
			IDispatch* pConnection =
				static_cast<IDispatch *>(punkConnection.p);
			if (pConnection)
			{
				CComVariant avarParams[1];
				avarParams[0].pbstrVal = pText;
				avarParams[0].vt = VT_BSTR | VT_BYREF;
				DISPPARAMS params = { avarParams, NULL, 1, 0 };
				hr = pConnection->Invoke(4,
					IID_NULL, LOCALE_USER_DEFAULT,
					DISPATCH_METHOD,
					&params, NULL, NULL, NULL);
			}
		}
		return hr;
	}

	HRESULT Fire_Konec(ULONG pocet, VARIANT_BOOL* pKoncit)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();

		for (int iConnection = 0;
			iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection =
				m_vec.GetAt(iConnection);
			pThis->Unlock();
			IDispatch* pConnection =
				static_cast<IDispatch *>(punkConnection.p);
			if (pConnection)
			{
				CComVariant avarParams[2];
				avarParams[1].ulVal = pocet;
				avarParams[1].vt = VT_UI4;
				avarParams[0].pboolVal = pKoncit;
				avarParams[0].vt = VT_BOOL | VT_BYREF;
				DISPPARAMS params = { avarParams, NULL, 2, 0 };
				hr = pConnection->Invoke(5,
					IID_NULL, LOCALE_USER_DEFAULT,
					DISPATCH_METHOD,
					&params, NULL, NULL, NULL);
			}
		}
		return hr;
	}
};
