/****************************************************
Pehrva multimedilnch soubor vyuvajc
ActiveX prvek MediaplayerAx
Soubor: VlastniPrehravac.cpp
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#include "stdafx.h"
#include "resource.h"
#include "VlastniPrehravac.h"

class Aplikace : public CAtlExeModuleT< Aplikace >,
	public CWindowImpl < Aplikace >,
	public IDispEventImpl< IDC_PREHRAVAC, Aplikace >

{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
					CS_DBLCLKS,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),
				(HCURSOR)NULL,
				(HBRUSH)GetSysColorBrush(COLOR_WINDOW),
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				L"MediaPrehravacHlavni",
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI))
			},
			NULL,
			NULL, // wndproc
			IDC_ARROW, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}

public:
	CString jmeno;
	CAxWindow2 axWindow;
	IMediaplayerAx* prehravacAx;
	CComBSTR soubor;

public :
	DECLARE_LIBID(LIBID_ATLLib)

	Aplikace()
	{
		prehravacAx = NULL;
	}

	BEGIN_MSG_MAP(Aplikace)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
		COMMAND_ID_HANDLER(ID_OTEVRIT, OnOtevrit)
		COMMAND_ID_HANDLER(ID_PRERUSIT, OnPrerusit)
		COMMAND_ID_HANDLER(ID_SPUSTIT, OnSpustit)
		COMMAND_ID_HANDLER(ID_ZASTAVIT, OnZastavit)
		COMMAND_ID_HANDLER(ID_ZAVRIT, OnZavrit)
	END_MSG_MAP()

	BEGIN_SINK_MAP(Aplikace)
		SINK_ENTRY(IDC_PREHRAVAC, 4, OnZmenaRozmeru)
	END_SINK_MAP()

	LRESULT OnClose(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		AtlAdviseSinkMap(this, false);
		if (axWindow.IsWindow())
			if (!axWindow.DestroyWindow())
				AtlThrowLastWin32();
		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (axWindow.IsWindow())
			axWindow.SetWindowPos(NULL, 0, 0,
			LOWORD(lParam), HIWORD(lParam),
			SWP_NOZORDER);
		return DefWindowProc();
	}

	HRESULT PreMessageLoop(int nShowCmd)
	{
		__super::PreMessageLoop(nShowCmd);
		Lock();
		INITCOMMONCONTROLSEX icc;
		icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC = ICC_WIN95_CLASSES |
			ICC_USEREX_CLASSES | ICC_DATE_CLASSES |
			ICC_LISTVIEW_CLASSES |
			ICC_COOL_CLASSES | ICC_BAR_CLASSES |
			ICC_INTERNET_CLASSES |
			ICC_NATIVEFNTCTL_CLASS |
			ICC_TAB_CLASSES | ICC_ANIMATE_CLASS;
		if (!InitCommonControlsEx(&icc))
			return E_FAIL;
		if (!jmeno.LoadString(IDS_PROJNAME))
			return E_FAIL;
		RECT rect = {0, 0, 800, 600};
		if (!Create(NULL, &rect, jmeno,
			WS_OVERLAPPED |	WS_CAPTION |
			WS_SYSMENU | WS_MINIMIZEBOX))
			return E_FAIL;
		HRESULT hr;
		axWindow.Create(m_hWnd, &rect, NULL, WS_CHILD,
			0, IDC_PREHRAVAC);
		hr = axWindow.CreateControl(
			L"RadekChalupa.MediaplayerAx");
		if (FAILED(hr))
			return E_FAIL;
		hr = axWindow.QueryControl(&prehravacAx);
		if (FAILED(hr))
			return E_FAIL;
		hr = AtlAdviseSinkMap(this, true);
		if (FAILED(hr))
			return false;
		axWindow.ShowWindow(SW_SHOW);
		EnableMenuItem(GetMenu(), ID_SPUSTIT,
			MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
		EnableMenuItem(GetMenu(), ID_PRERUSIT,
			MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
		EnableMenuItem(GetMenu(), ID_ZASTAVIT,
			MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
		CenterWindow();
		ShowWindow(SW_SHOW);
		return S_OK;
	}
    
	HRESULT PostMessageLoop()
	{
		Unlock();
		return __super::PostMessageLoop();
	}

	LRESULT OnKonec(WORD, WORD, HWND, BOOL&)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnOtevrit(WORD, WORD, HWND, BOOL&)
	{
		if (!prehravacAx)
			return 0;
		if (prehravacAx->VybratSoubor(&soubor) == S_OK)
		{
			EnableMenuItem(GetMenu(), ID_SPUSTIT,
				MF_ENABLED | MF_BYCOMMAND);
			EnableMenuItem(GetMenu(), ID_PRERUSIT,
				MF_ENABLED | MF_BYCOMMAND);
			EnableMenuItem(GetMenu(), ID_ZASTAVIT,
				MF_ENABLED | MF_BYCOMMAND);
		}
		CComBSTR bstrSoubor;
		prehravacAx->get_soubor(&bstrSoubor);
		CString text;
		text.Format(L"%s - %s",
			PathFindFileName(bstrSoubor.m_str),
			jmeno.GetBuffer());
		SetWindowText(text);
		return 0;
	}

	LRESULT OnPrerusit(WORD, WORD, HWND, BOOL&)
	{
		if (prehravacAx)
			prehravacAx->Prerusit();
		return 0;
	}

	LRESULT OnSpustit(WORD, WORD, HWND, BOOL&)
	{
		if (prehravacAx)
			prehravacAx->Spustit();
		return 0;
	}

	LRESULT OnZastavit(WORD, WORD, HWND, BOOL&)
	{
		if (prehravacAx)
			prehravacAx->Zastavit();
		return 0;
	}

	LRESULT OnZavrit(WORD, WORD, HWND, BOOL&)
	{
		if (prehravacAx)
			prehravacAx->Zavrit();
		EnableMenuItem(GetMenu(), ID_SPUSTIT,
			MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
		EnableMenuItem(GetMenu(), ID_PRERUSIT,
			MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
		EnableMenuItem(GetMenu(), ID_ZASTAVIT,
			MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
		SetWindowText(jmeno);
		return 0;
	}

	void __stdcall OnZmenaRozmeru(
		ULONG sirka, ULONG vyska)
	{
		if (sirka < 350)
			sirka = 350;
		if (vyska < 300)
			vyska = 300;
		RECT rect = {0, 0, sirka, vyska};
		AdjustWindowRectEx(&rect,
			WS_CAPTION | WS_SYSMENU | WS_BORDER,
			TRUE, 0);
		SetWindowPos(NULL, 0, 0,
			rect.right - rect.left,
			rect.bottom - rect.top,
			SWP_NOZORDER | SWP_NOMOVE);
	}

};

Aplikace _AtlModule;

// hlavn funkce Win32 GUI aplikace
extern "C" int WINAPI _tWinMain(HINSTANCE,
	HINSTANCE, LPTSTR, int nShowCmd)
{
    return _AtlModule.WinMain(nShowCmd);
}
