// VlastnostiAx.h : Declaration of the VlastnostiAx
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "VlastnostiAxObj.h"
#include "_IVlastnostiAxEvents_CP.h"

// VlastnostiAx
class ATL_NO_VTABLE VlastnostiAx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<VlastnostiAx, IVlastnostiAx>,
	public IPersistStreamInitImpl<VlastnostiAx>,
	public IOleControlImpl<VlastnostiAx>,
	public IOleObjectImpl<VlastnostiAx>,
	public IOleInPlaceActiveObjectImpl<VlastnostiAx>,
	public IViewObjectExImpl<VlastnostiAx>,
	public IOleInPlaceObjectWindowlessImpl<VlastnostiAx>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<VlastnostiAx>,
	public CProxy_IVlastnostiAxEvents<VlastnostiAx>, 
	public IPersistStorageImpl<VlastnostiAx>,
	public ISpecifyPropertyPagesImpl<VlastnostiAx>,
	public IQuickActivateImpl<VlastnostiAx>,
	public IDataObjectImpl<VlastnostiAx>,
	public IProvideClassInfo2Impl<&CLSID_VlastnostiAx, &__uuidof(_IVlastnostiAxEvents), &LIBID_VlastnostiAxObjLib>,
	public CComCoClass<VlastnostiAx, &CLSID_VlastnostiAx>,
	public CComControl<VlastnostiAx>
{
private:
	CComBSTR nazev;
	CComBSTR nevizualniText;
	ULONG cislo;
	COLORREF mojeBarva;

public:
	VlastnostiAx()
	{
		nazev = L"Vlastnosti ActiveX";
		nevizualniText = L"Nevizuln text";
		cislo = 1962;
		mojeBarva = 0x000000A0;
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_VLASTNOSTIAX)

BEGIN_COM_MAP(VlastnostiAx)
	COM_INTERFACE_ENTRY(IVlastnostiAx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(VlastnostiAx)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("BackColor", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("Nazev", 2, CLSID_NULL)
	PROP_ENTRY("Cislo", 3, CLSID_NULL)
	PROP_ENTRY("Moje barva", 4, CLSID_StockColorPage)
	PROP_PAGE(CLSID_VlastnostiAxPP)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(VlastnostiAx)
	CONNECTION_POINT_ENTRY(__uuidof(_IVlastnostiAxEvents))
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(VlastnostiAx)
	CHAIN_MSG_MAP(CComControl<VlastnostiAx>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IVlastnostiAx,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IVlastnostiAx
public:
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		CString text;
		COLORREF cr;
		OleTranslateColor(m_clrBackColor,
			NULL, &cr);
		text.Format(L"Nzev: %s\n"
			L"slo: %d\n"
			L"Nevizuln text: %s",
			nazev.m_str,
			cislo,
			nevizualniText.m_str);
		HBRUSH hb = CreateSolidBrush(cr);
		FillRect(di.hdcDraw,
			&rc,
			hb);
		SetBkMode(di.hdcDraw, TRANSPARENT);
		SetTextColor(di.hdcDraw,
			mojeBarva);
		DrawText(di.hdcDraw,
			text.GetBuffer(),
			-1,
			&rc,
			DT_CENTER);
		if (!DeleteObject(hb))
			AtlThrowLastWin32();
		return S_OK;
	}

	OLE_COLOR m_clrBackColor;
	void OnBackColorChanged()
	{
		ATLTRACE(_T("OnBackColorChanged\n"));
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	STDMETHOD(get_NevizualniText)(BSTR* pText)
	{
		this->nevizualniText.CopyTo(pText);
		return S_OK;
	}

	STDMETHOD(put_NevizualniText)(BSTR novyText)
	{
		this->nevizualniText = CComBSTR(novyText);
		FireViewChange();
		Fire_ZmenaNevizualniText(this->nevizualniText);
		return S_OK;
	}

	STDMETHOD(get_Nazev)(BSTR* pNazev)
	{
		this->nazev.CopyTo(pNazev);
		return S_OK;
	}

	STDMETHOD(put_Nazev)(BSTR novyNazev)
	{
		this->nazev = CComBSTR(novyNazev);
		FireViewChange();
		Fire_ZmenaNazev(this->nazev);
		return S_OK;
	}

	STDMETHOD(get_Cislo)(ULONG* pCislo)
	{
		*pCislo = this->cislo;
		return S_OK;
	}

	STDMETHOD(put_Cislo)(ULONG noveCislo)
	{
		this->cislo = noveCislo;
		FireViewChange();
		Fire_ZmenaCislo(this->cislo);
		return S_OK;
	}

	STDMETHOD(get_MojeBarva)(OLE_COLOR* pBarva)
	{
		*pBarva = mojeBarva;
		return S_OK;
	}

	STDMETHOD(put_MojeBarva)(OLE_COLOR novaBarva)
	{
		OleTranslateColor(novaBarva,
			NULL, &this->mojeBarva);
		FireViewChange();
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(VlastnostiAx), VlastnostiAx)
