// VlastnostiAxPP.h : Declaration of the VlastnostiAxPP


#pragma once

#include "resource.h"       // main symbols
#include "VlastnostiAxObj.h"

// VlastnostiAxPP

class ATL_NO_VTABLE VlastnostiAxPP :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<VlastnostiAxPP, &CLSID_VlastnostiAxPP>,
	public IPropertyPageImpl<VlastnostiAxPP>,
	public CDialogImpl<VlastnostiAxPP>
{
public:
	VlastnostiAxPP() 
	{
		m_dwTitleID = IDS_TITLEVlastnostiAxPP;
		m_dwHelpFileID = IDS_HELPFILEVlastnostiAxPP;
		m_dwDocStringID = IDS_DOCSTRINGVlastnostiAxPP;
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	enum {IDD = IDD_VLASTNOSTIAXPP};

DECLARE_REGISTRY_RESOURCEID(IDR_VLASTNOSTIAXPP)


BEGIN_COM_MAP(VlastnostiAxPP) 
	COM_INTERFACE_ENTRY(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(VlastnostiAxPP)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDC_CISLO,
		EN_CHANGE, OnZmena)
	COMMAND_HANDLER(IDC_NAZEV,
		EN_CHANGE, OnZmena)
	COMMAND_HANDLER(IDC_NEVIZUALNI_TEXT,
		EN_CHANGE, OnZmena)
	CHAIN_MSG_MAP(IPropertyPageImpl<VlastnostiAxPP>)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	STDMETHOD(Apply)()
	{
		ATLTRACE(_T("VlastnostiAxPP::Apply\n"));
		ULONG cislo;
		CString text;
		for (UINT i = 0; i < m_nObjects; i++)
		{
			CComQIPtr<IVlastnostiAx, &IID_IVlastnostiAx> p(m_ppUnk[i]);
			cislo = GetDlgItemInt(IDC_CISLO);
			p->put_Cislo(cislo);
			GetDlgItemText(IDC_NAZEV, text);
			p->put_Nazev(text.GetBuffer());
			GetDlgItemText(IDC_NEVIZUALNI_TEXT, text);
			p->put_NevizualniText(text.GetBuffer());
			p.Release();
		}
		m_bDirty = FALSE;
		return S_OK;
	}

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		ULONG cislo;
		CComBSTR text;
		for (UINT i = 0; i < m_nObjects; i++)
		{
			CComQIPtr<IVlastnostiAx, &IID_IVlastnostiAx> p(m_ppUnk[i]);
			p->get_Cislo(&cislo);
			SetDlgItemInt(IDC_CISLO, cislo);
			p->get_Nazev(&text);
			SetDlgItemText(IDC_NAZEV, text);
			p->get_NevizualniText(&text);
			SetDlgItemText(IDC_NEVIZUALNI_TEXT, text);
			p.Release();
		}
		return TRUE;
	}

	LRESULT OnZmena(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		SetDirty(TRUE);
		return 0;
	}
};


OBJECT_ENTRY_AUTO(__uuidof(VlastnostiAxPP), VlastnostiAxPP)
