/****************************************************
Tda: DlgVlastnostiStranky
Soubor: DlgVlastnostiStranky.cpp
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#include "stdafx.h"
#include ".\DlgVlastnostiStranky.h"

LRESULT DlgVlastnostiStranky::OnInitDialog(
	UINT uMsg, WPARAM wParam,
	LPARAM lParam, BOOL& bHandled)
{
	if (!lParam)
	{
		EndDialog(IDCANCEL);
		return 1;
	}
	btnOK.SubclassWindow(GetDlgItem(IDOK));
	btnZobrazitObrazek.SubclassWindow(
		GetDlgItem(IDC_ZOBRAZIT_OBRAZEK));
	CComBSTR bstr;
	CString strText;
	SetIcon(LoadIcon(NULL, IDI_INFORMATION), FALSE);
	SetIcon(LoadIcon(_AtlBaseModule.m_hInst,
		MAKEINTRESOURCE(IDI_HLAVNI)), TRUE);
	this->webBrowser =
		(IWebBrowser2*)lParam;
	webBrowser->get_LocationName(&bstr);
	SetWindowText(bstr.m_str);
	webBrowser->get_LocationURL(&bstr);
	strText.Format(L"URL: %s", bstr.m_str);
	SetDlgItemText(IDC_URL, strText.GetBuffer());
	CComPtr<IHTMLDocument2> dok;
	HRESULT hr = webBrowser->get_Document((IDispatch**) &dok);
	if (hr != S_OK)
		return 1;
	IHTMLElementCollection* elementy;
	hr = dok->get_fileSize(&bstr);
	if (hr != S_OK)
		return 1;
	strText.Format(L"Velikost souboru: %d bajt", bstr.m_str);
	SetDlgItemText(IDC_VELIKOST_SOUBORU, strText);
	hr = dok->get_images(&elementy);
	if (hr != S_OK)
		return 1;
	long pocet;
	elementy->get_length(&pocet);
	VARIANT varIndex;
	VARIANT varName;
	VariantInit(&varName);
	varIndex.vt = VT_UINT;
	IDispatch* pDispatch;
	VARIANT varText;
	varText.vt = VT_BSTR;
	IHTMLImgElement* imgElement;
	SendDlgItemMessage(IDC_OBRAZKY, LB_RESETCONTENT);
	int polozka;
	for (long i = 0; i < pocet; i++)
	{
		varIndex.lVal = i;
		hr = elementy->item(varIndex, varName,
			(IDispatch**)&pDispatch);
		if (hr != S_OK)
			continue;
		hr = pDispatch->QueryInterface(IID_IHTMLImgElement,
			(void**)&imgElement);
		if (hr != S_OK )
			continue;
		imgElement->get_href(&bstr);
		if (hr != S_OK)
			continue;
		strText = CString(bstr);
		imgElement->get_fileSize(&bstr);
		if (hr != S_OK)
			continue;
		strText.Append(L" ( ");
		strText.Append(bstr.m_str);
		strText.Append(L" bajt )");
		polozka = (int)SendDlgItemMessage(IDC_OBRAZKY,
			LB_ADDSTRING,0, (LPARAM)strText.GetBuffer());
		SendDlgItemMessage(IDC_OBRAZKY,
			LB_SETITEMDATA, polozka,
			(LPARAM)imgElement);
	}
	return 1;
}

void DlgVlastnostiStranky::ZobrazitObrazek()
{
	int vyber = SendDlgItemMessage(IDC_OBRAZKY,
		LB_GETCURSEL);
	if (vyber < 0)
		return;
	IHTMLImgElement* imgElement =
		(IHTMLImgElement*)SendDlgItemMessage(
			IDC_OBRAZKY, LB_GETITEMDATA, vyber);
	CComBSTR bstr;
	HRESULT hr = imgElement->get_href(&bstr);
	if (hr != S_OK)
		return;
	wchar_t* ext = PathFindExtension(bstr.m_str);
	if (!ext)
		return;
	CString soubor;
	soubor.Format(L"temp%s", ext);
	URLDownloadToFile(NULL, bstr.m_str,
		soubor.GetBuffer(), 0, NULL);
	ShellExecute(NULL, L"Open", soubor,
		NULL, NULL, SW_SHOW);
}

LRESULT DlgVlastnostiStranky::OnLbnDblclkObrazky(
	WORD wNotifyCode, WORD wID,
	HWND hWndCtl, BOOL& bHandled)
{
	ZobrazitObrazek();
	return 0;
}

LRESULT DlgVlastnostiStranky::OnZobrazitObrazek(
	WORD wNotifyCode, WORD wID,
	HWND hWndCtl, BOOL& bHandled)
{
	ZobrazitObrazek();
	return 0;
}
