#pragma once

/****************************************************
Tda: EditUrl
Soubor: EditUrl.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

class EditUrl : public CWindowImpl< EditUrl >
{
public:
	DECLARE_WND_SUPERCLASS(L"EditUrl", WC_EDIT)
	IWebBrowser2* webBrowser;
public:
	EditUrl()
	{
		webBrowser = NULL;
	}

	BEGIN_MSG_MAP(EditUrl)
		MESSAGE_HANDLER(WM_GETDLGCODE, OnGetDlgCode)
		MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

	void Nastavit(HWND hwnd, IWebBrowser2* webBrowser)
	{
		SubclassWindow(hwnd);
		this->webBrowser = webBrowser;
	}

	LRESULT OnGetDlgCode(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		return DLGC_WANTALLKEYS;
	}

	LRESULT OnKeyDown(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		switch (wParam)
		{
		case VK_RETURN:
			if (webBrowser)
			{
				CString url;
				GetWindowText(url);
				webBrowser->Navigate(url.GetBuffer(),
					NULL, NULL, NULL, NULL);
			}
			break;
		}
		return DefWindowProc();
	}
};
