/****************************************************
Soubor: OknoHlavni.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include ".\DlgHlavni.h"
#include ".\DlgVlastnostiStranky.h"

class OknoHlavni : public CWindowImpl< OknoHlavni >
{
public:
	static CWndClassInfo& GetWndClassInfo()
	{
		static CWndClassInfo wc =
		{
			{
				sizeof(WNDCLASSEX),
				CS_DBLCLKS,
				StartWindowProc,
				0, 0,
				NULL,
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)),// ikona
				(HCURSOR)NULL,
				(HBRUSH)NULL,
				MAKEINTRESOURCE(IDR_HLAVNI), // menu
				_T("MojeHlavniOkno"),
				(HICON)LoadIcon(_AtlBaseModule.m_hInst,
					MAKEINTRESOURCE(IDI_HLAVNI)) // mal ikona
			},
			NULL,
			NULL, // wndproc
			IDC_CROSS, // ID sys. kurzoru
			TRUE, // systemovy kursor
			0, // atom
			L""
		};
		return wc;
	}

public:
	DlgHlavni* dlgHlavni;
	AtlDemo::StatusBar* statusBar;
	AtlDemo::ToolBar* toolBar;
	CString strStatus;

public:
	OknoHlavni()
	{
		dlgHlavni = NULL;
		statusBar = NULL;
	}

	~OknoHlavni()
	{
		if (dlgHlavni)
			delete dlgHlavni;
	}

	BEGIN_MSG_MAP(OknoHlavni)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_MENUSELECT, OnMenuSelect)
		MESSAGE_HANDLER(WM_NOTIFY, OnNotify)
		COMMAND_ID_HANDLER(ID_KONEC, OnKonec)
		COMMAND_ID_HANDLER(ID_VLASTNOSTI_STRANKY, OnVlastnostiStranky)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
	END_MSG_MAP()

	bool Vytvorit();

	LRESULT OnClose(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (statusBar)
		{
			delete statusBar;
			statusBar = NULL;
		}
		return DefWindowProc();
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		PostQuitMessage(0);
		return DefWindowProc();
	}

	LRESULT OnKonec(WORD wNotifyCode, WORD wID,
		HWND hWndCtl, BOOL& bHandled)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}

	LRESULT OnVlastnostiStranky(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (dlgHlavni->webBrowser)
		{
			DlgVlastnostiStranky dlg;
			dlg.DoModal(m_hWnd, (LPARAM)
				dlgHlavni->webBrowser);
		}
		return 0;
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		RECT rectSB = {0, 0, 0, 0};
		RECT rectTB = {0, 0, 0, 0};
		if (this->statusBar)
		{
			statusBar->SendMessage(uMsg, wParam, lParam);
			statusBar->GetWindowRect(&rectSB);
		}
		if (this->toolBar)
		{
			toolBar->SendMessage(uMsg, wParam, lParam);
			toolBar->GetWindowRect(&rectTB);
		}
		if (dlgHlavni)
			dlgHlavni->SetWindowPos(NULL,
			0,
			(rectTB.bottom - rectTB.top),
			LOWORD(lParam),
			HIWORD(lParam) -
				(rectSB.bottom - rectSB.top) -
				(rectTB.bottom - rectTB.top),
			SWP_NOZORDER);
		return DefWindowProc();
	}

	LRESULT OnMenuSelect(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		if (statusBar)
		{
			CString strText;
			if (strText.LoadString(LOWORD(wParam)))
			{
				strText.Replace(L'\n', L'\0');
				statusBar->SetText(strText.GetBuffer(), 0);
			}
			else
				SetStatusText();
		}
		return DefWindowProc();
	}

	LRESULT OnNotify(UINT uMsg, WPARAM wParam,
		LPARAM lParam, BOOL& bHandled)
	{
		static NMTTDISPINFOW* pTTDISPINFO;
		CString strText;
		if (((NMHDR*)lParam)->code == TTN_GETDISPINFO)
		{
			pTTDISPINFO = (NMTTDISPINFOW*)lParam;
			pTTDISPINFO->hinst = _AtlBaseModule.m_hInst;
			if (strText.LoadString(pTTDISPINFO->hdr.idFrom))
			{
				wcscpy(pTTDISPINFO->lpszText,
					strText.GetBuffer());
			}
		}
		bHandled = FALSE;
		return DefWindowProc();
	}

	void SetStatusText(const TCHAR* text = NULL)
	{
		if (text)
			strStatus = CString(text);
		if (statusBar)
			statusBar->SetText(strStatus.GetBuffer(), 0);
	}
};

extern OknoHlavni _oknoHlavni;