/****************************************************
ZaznamZvuku ActveX
Soubor: ZaznamZvukuAx.h
(C) 2005 Radek Chalupa - www.radekchalupa.cz
*****************************************************/

#pragma once

#include "resource.h"
#include <atlctl.h>
#include "ZaznamZvukuObj.h"
#include "_IZaznamZvukuAxEvents_CP.h"

// ZaznamZvukuAx
class ATL_NO_VTABLE ZaznamZvukuAx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IZaznamZvukuAx,
		&IID_IZaznamZvukuAx,
		&LIBID_ZaznamZvukuObjLib, 1, 0>,
	public IPersistStreamInitImpl<ZaznamZvukuAx>,
	public IOleControlImpl<ZaznamZvukuAx>,
	public IOleObjectImpl<ZaznamZvukuAx>,
	public IOleInPlaceActiveObjectImpl<ZaznamZvukuAx>,
	public IViewObjectExImpl<ZaznamZvukuAx>,
	public IOleInPlaceObjectWindowlessImpl<ZaznamZvukuAx>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<ZaznamZvukuAx>,
	public CProxy_IZaznamZvukuAxEvents<ZaznamZvukuAx>, 
	public IPersistStorageImpl<ZaznamZvukuAx>,
	public ISpecifyPropertyPagesImpl<ZaznamZvukuAx>,
	public IQuickActivateImpl<ZaznamZvukuAx>,
	public IDataObjectImpl<ZaznamZvukuAx>,
	public IProvideClassInfo2Impl<&CLSID_ZaznamZvukuAx,
		&__uuidof(_IZaznamZvukuAxEvents),
		&LIBID_ZaznamZvukuObjLib>,
	public CComCoClass<ZaznamZvukuAx, &CLSID_ZaznamZvukuAx>,
	public CComCompositeControl<ZaznamZvukuAx>
{
public:
	Button btnSpustit;
	Button btnUlozit;
	Button btnZrusit;
	Button btnVybratSoubor;
	Button btnPrehrat;
	Button btnZastavit;

	bool probihaZaznam;
	CString soubor;
	MCI_OPEN_PARMS mciOpen;
	MCI_RECORD_PARMS mciRecord;
	MCI_SAVE_PARMS mciSave;
	MCI_PLAY_PARMS mciPlay;
	DWORD dwResult;
	WORD wDeviceID;

public:
	ZaznamZvukuAx()
	{
		m_bWindowOnly = TRUE;
		CalcExtent(m_sizeExtent);
		probihaZaznam = false;
		this->wDeviceID = 0;
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_ZAZNAMZVUKUAX)

BEGIN_COM_MAP(ZaznamZvukuAx)
	COM_INTERFACE_ENTRY(IZaznamZvukuAx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow,
		IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(ZaznamZvukuAx)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(ZaznamZvukuAx)
	CONNECTION_POINT_ENTRY(__uuidof(_IZaznamZvukuAxEvents))
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(ZaznamZvukuAx)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDC_SPUSTIT, BN_CLICKED, OnSpustit)
	COMMAND_HANDLER(IDC_ULOZIT, BN_CLICKED, OnUlozit)
	COMMAND_HANDLER(IDC_VYBRAT_SOUBOR,
		BN_CLICKED, OnVybratSoubor)
	COMMAND_HANDLER(IDC_ZRUSIT, BN_CLICKED, OnZrusit)
	COMMAND_HANDLER(IDC_PREHRAT, BN_CLICKED, OnPrehrat)
	COMMAND_HANDLER(IDC_ZASTAVIT, BN_CLICKED, OnZastavit)
	CHAIN_MSG_MAP(CComCompositeControl<ZaznamZvukuAx>)
END_MSG_MAP()

BEGIN_SINK_MAP(ZaznamZvukuAx)
END_SINK_MAP()

	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid)
	{
		if (dispid == DISPID_AMBIENT_BACKCOLOR)
		{
			SetBackgroundColorFromAmbient();
			FireViewChange();
		}
		return IOleControlImpl<ZaznamZvukuAx>::
			OnAmbientPropertyChange(dispid);
	}
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IZaznamZvukuAx,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(
		VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IZaznamZvukuAx

	enum { IDD = IDD_ZAZNAMZVUKUAX };

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

	void Chyba(DWORD dwChyba)
	{
		wchar_t szText[1024];
		mciGetErrorString(dwChyba, szText,
			sizeof(szText) / sizeof(wchar_t));
		MessageBox(szText, L"Zznam zvuku",
			MB_ICONERROR | MB_SETFOREGROUND);
	}

	bool SetSoubor(const wchar_t* pszSoubor)
	{
		wchar_t* lpPripona = PathFindExtension(pszSoubor);
		if (!lpPripona)
			return false;
		else
		{
			if (lstrcmpi(lpPripona+1, L"wav") != 0)
				return false;
		}
		this->soubor = CString(pszSoubor);
		return true;
	}

	LRESULT OnInitDialog(UINT uMsg,
		WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if (!SUCCEEDED(SHGetFolderPath(NULL,
			CSIDL_PERSONAL, NULL, SHGFP_TYPE_CURRENT,
			soubor.GetBufferSetLength(MAX_PATH))))
			return false;
		soubor.ReleaseBuffer();
		if (!PathFileExists(soubor.GetBuffer()))
			return 1;
		soubor.Append(L"\\zaznam.wav");
		SetDlgItemText(IDC_SOUBOR, soubor);
		GetDlgItem(IDC_ULOZIT).EnableWindow(FALSE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(FALSE);
		btnSpustit.SubclassWindow(GetDlgItem(IDC_SPUSTIT));
		btnUlozit.SubclassWindow(GetDlgItem(IDC_ULOZIT));
		btnVybratSoubor.SubclassWindow(
			GetDlgItem(IDC_VYBRAT_SOUBOR));
		btnZrusit.SubclassWindow(GetDlgItem(IDC_ZRUSIT));
		btnPrehrat.SubclassWindow(GetDlgItem(IDC_PREHRAT));
		btnZastavit.SubclassWindow(GetDlgItem(IDC_ZASTAVIT));
		SendDlgItemMessage(IDC_SOUBOR, EM_SETSEL, 0, -1);
		SendDlgItemMessage(IDC_SOUBOR, EM_SETSEL, -1);
		return 1;
	}

	LRESULT OnSpustit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (probihaZaznam)
			return 0;
		CString text;
		GetDlgItemText(IDC_SOUBOR, text);
		if (!SetSoubor(text.GetBuffer()))
			return 0;
		this->mciOpen.dwCallback = 0;
		this->mciOpen.lpstrAlias = NULL;
		this->mciOpen.lpstrDeviceType = L"waveaudio";
		this->mciOpen.lpstrElementName = L"";
		this->mciOpen.wDeviceID = 0;
		this->dwResult = mciSendCommand(0, MCI_OPEN,
			MCI_WAIT | MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,
			(DWORD_PTR)(LPMCI_OPEN_PARMSW)&this->mciOpen);
		if (this->dwResult != 0)
		{
			Chyba(this->dwResult);
			return false;
		}
		this->wDeviceID = this->mciOpen.wDeviceID;
		this->mciRecord.dwCallback = (DWORD)this->m_hWnd;
		this->mciRecord.dwFrom = 0;
		this->mciRecord.dwTo = 0;
		mciSendCommand(this->wDeviceID,
			MCI_RECORD, MCI_NOTIFY,
			(DWORD_PTR)(LPMCI_RECORD_PARMS)&this->mciRecord);
		this->probihaZaznam = true;
		GetDlgItem(IDC_ULOZIT).EnableWindow(TRUE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(TRUE);
		GetDlgItem(IDC_SPUSTIT).EnableWindow(FALSE);
		GetDlgItem(IDC_VYBRAT_SOUBOR).EnableWindow(FALSE);
		GetDlgItem(IDC_PREHRAT).EnableWindow(FALSE);
		GetDlgItem(IDC_ZASTAVIT).EnableWindow(FALSE);

		text.Format(IDS_PROBIHA_ZAZNAM,
			PathFindFileName(soubor.GetBuffer()));
		SetDlgItemText(IDC_STAV, text);
		return 0;
	}

	LRESULT OnUlozit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (!this->probihaZaznam)
			return 0;
		MCI_GENERIC_PARMS mciGeneric;
		mciGeneric.dwCallback = 0;
		mciSendCommand (this->wDeviceID,
			MCI_STOP, MCI_WAIT,
			(DWORD_PTR)(LPMCI_GENERIC_PARMS)&mciGeneric);
		this->mciSave.dwCallback = 0;
		this->mciSave.lpfilename = this->soubor.GetBuffer();
		mciSendCommand(this->wDeviceID,
			MCI_SAVE, MCI_WAIT | MCI_SAVE_FILE,
			(DWORD_PTR)(LPMCI_SAVE_PARMS)&this->mciSave);
		mciSendCommand(this->wDeviceID, MCI_CLOSE, MCI_WAIT,
			(DWORD_PTR)(LPMCI_GENERIC_PARMS)&mciGeneric);
		this->probihaZaznam = false;
		SetDlgItemText(IDC_STAV, L"Pipraven");
		GetDlgItem(IDC_ULOZIT).EnableWindow(FALSE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(FALSE);
		GetDlgItem(IDC_SPUSTIT).EnableWindow(TRUE);
		GetDlgItem(IDC_VYBRAT_SOUBOR).EnableWindow(TRUE);
		GetDlgItem(IDC_PREHRAT).EnableWindow(TRUE);
		GetDlgItem(IDC_ZASTAVIT).EnableWindow(TRUE);
		return 0;
	}

	LRESULT OnZrusit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		if (!this->probihaZaznam)
			return false;
		MCI_GENERIC_PARMS mciGeneric;
		mciGeneric.dwCallback = 0;
		mciSendCommand (this->wDeviceID,
			MCI_STOP, MCI_WAIT,
			(DWORD_PTR)(LPMCI_GENERIC_PARMS)&mciGeneric);
		this->mciSave.dwCallback = 0;
		mciSendCommand(this->wDeviceID,
			MCI_CLOSE, MCI_WAIT,
			(DWORD_PTR)(LPMCI_GENERIC_PARMS)&mciGeneric);
		this->probihaZaznam = false;
		SetDlgItemText(IDC_STAV, L"Pipraven");
		GetDlgItem(IDC_ULOZIT).EnableWindow(FALSE);
		GetDlgItem(IDC_ZRUSIT).EnableWindow(FALSE);
		GetDlgItem(IDC_SPUSTIT).EnableWindow(TRUE);
		GetDlgItem(IDC_VYBRAT_SOUBOR).EnableWindow(TRUE);
		GetDlgItem(IDC_PREHRAT).EnableWindow(TRUE);
		GetDlgItem(IDC_ZASTAVIT).EnableWindow(TRUE);
		return 0;
	}

	LRESULT OnVybratSoubor(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		OPENFILENAME ofn;
		wchar_t szSoubor[MAX_PATH];
		wcsncpy(szSoubor,
			this->soubor.GetBuffer(), MAX_PATH);
		memset(&ofn, 0, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.lpstrFile = szSoubor;
		ofn.nMaxFile = MAX_PATH;
		ofn.hwndOwner = m_hWnd;
		ofn.lpstrFilter =
			L"Zvukov soubory WAVE (*.wav)\0"
			L"*.wav\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrDefExt = L"wav";
		ofn.Flags = OFN_PATHMUSTEXIST;
		if (!GetSaveFileName(&ofn))
			return false;
		this->soubor = CString(szSoubor);
		SetDlgItemText(IDC_SOUBOR, this->soubor);
		SendDlgItemMessage(IDC_SOUBOR, EM_SETSEL, 0, -1);
		SendDlgItemMessage(IDC_SOUBOR, EM_SETSEL, -1);
		return 0;
	}

	LRESULT OnPrehrat(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CString text;
		GetDlgItemText(IDC_SOUBOR, text);
		PlaySound(text.GetBuffer(),
			NULL,
			SND_FILENAME | SND_ASYNC);
		return 0;
	}

	LRESULT OnZastavit(WORD wNotifyCode,
		WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		PlaySound(NULL,	NULL,
			SND_FILENAME | SND_ASYNC);
		return 0;
	}

	virtual HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		if(!m_bInPlaceActive)
		{
			HPEN hPen = (HPEN)
				::GetStockObject(BLACK_PEN);
			HBRUSH hBrush = (HBRUSH)
				::GetStockObject(WHITE_BRUSH);
			SelectObject(di.hdcDraw, hPen);
			SelectObject(di.hdcDraw, hBrush);
			Rectangle(di.hdcDraw,
				di.prcBounds->left,
				di.prcBounds->top,
				di.prcBounds->right,
				di.prcBounds->bottom);
			SetTextColor(di.hdcDraw,
				GetSysColor(COLOR_WINDOWTEXT));
			SetBkMode(di.hdcDraw, TRANSPARENT);
			DrawText(di.hdcDraw,
				L"Zznam zvuku ActiveX",
				-1,
				(LPRECT)di.prcBounds,
				DT_CENTER | DT_SINGLELINE
				| DT_VCENTER);
		}
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(ZaznamZvukuAx),
				  ZaznamZvukuAx)
